Package: immunotation
Type: Package
Title: Tools for working with diverse immune genes
Version: 1.20.0
Date: 2021-08-09
Authors@R: c(
    person("Katharina", "Imkeller", email = "ag.imkeller@gmail.com", role = c("cre", "aut")))
Description: MHC (major histocompatibility complex) molecules are cell surface complexes that present antigens to T cells.  The repertoire of antigens presented in a given genetic background largely depends on the sequence of the encoded MHC molecules, and thus, in humans, on the highly variable HLA (human leukocyte antigen) genes of the hyperpolymorphic HLA locus. More than 28,000 different HLA alleles have been reported, with significant differences in allele frequencies between human populations worldwide. Reproducible and consistent annotation of HLA alleles in large-scale bioinformatics workflows remains challenging, because the available reference databases and software tools often use different HLA naming schemes. The package immunotation provides tools for consistent annotation of HLA genes in typical immunoinformatics workflows such as for example the prediction of MHC-presented peptides in different human donors. Converter functions that provide mappings between different HLA naming schemes are based on the MHC restriction ontology (MRO). The package also provides automated access to HLA alleles frequencies in worldwide human reference populations stored in the Allele Frequency Net Database.
License: GPL-3
Encoding: UTF-8
Collate: 'external_resources_input.R' 'AFND_interface.R'
        'MRO_interface_helper.R' 'MRO_interface.R' 'MACUI_interface.R'
        'nomenclature_queries.R' 'AFND_queries.R' 'visualization.R'
Depends: R (>= 4.1)
Imports: stringr, ontologyIndex, curl, ggplot2, readr, rvest, tidyr,
        xml2, maps, rlang
Suggests: BiocGenerics, rmarkdown, BiocStyle, knitr, testthat, DT
VignetteBuilder: knitr
RoxygenNote: 7.1.1
biocViews: Software, ImmunoOncology, BiomedicalInformatics, Genetics,
        Annotation
BugReports: https://github.com/imkeller/immunotation/issues
git_url: https://git.bioconductor.org/packages/immunotation
git_branch: RELEASE_3_23
git_last_commit: 0725d76
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:49:21 UTC; biocbuild
Author: Katharina Imkeller [cre, aut]
Maintainer: Katharina Imkeller <ag.imkeller@gmail.com>

convert_string <- function(value) {
    # we need this function to format the lists in the sting
    # and replace the NA values in the URL with ""
    if (length(value) > 1) {value <- paste(value, collapse=",")}
    else if(is.na(value)) {""}
    else if(grepl(" ", value)) {stringr::str_replace(value, " ", "%20")}
    else value
}

# get the list of valid alleles
retrieve_AFND_valid_allele_list <- function(locus) {
    check_hla_locus(locus)
    query_alleles_url <- sprintf(paste0("http://www.allelefrequencies.net/",
    "hla6006c.asp?hla_locus=%s&hla_locus_type=Classical"), locus)
    
    html_input <- getURL(query_alleles_url, read_method = "html")
    
    rvest_tables <- rvest::html_table(html_input, fill = TRUE)
    valid_alleles <- rvest_tables[[3]]$X1
    valid_alleles
}

# Update the stored valid allele list 
update_valid_alleles <- function () {
    valid_alleles <- retrieve_AFND_valid_allele_list(locus = "A")
    valid_alleles_B <- retrieve_AFND_valid_allele_list(locus = "B")
    valid_alleles_C <- retrieve_AFND_valid_allele_list(locus = "C")
    valid_alleles_DPA1 <- retrieve_AFND_valid_allele_list(locus = "DPA1")
    valid_alleles_DPB1 <- retrieve_AFND_valid_allele_list(locus = "DPB1")
    valid_alleles_DQA1 <- retrieve_AFND_valid_allele_list(locus = "DQA1")
    valid_alleles_DQB1 <- retrieve_AFND_valid_allele_list(locus = "DQB1")
    valid_alleles_DRB1 <- retrieve_AFND_valid_allele_list(locus = "DRB1")
    
    complete_list <- c(valid_alleles, valid_alleles_B,
        valid_alleles_C, valid_alleles_DPA1, valid_alleles_DPB1,
        valid_alleles_DQA1, valid_alleles_DQB1, valid_alleles_DRB1)
    saveRDS(complete_list, system.file("extdata", "AFND_valid_alleles.RData",
        package = "immunotation"))
    return(complete_list)
}

get_valid_allele_list <- function() {
    file_name <- system.file("extdata", "AFND_valid_alleles.RData",
        package = "immunotation")
    if (file.exists(file_name)) {
        complete_list <- readRDS(file_name)
    } else {
        complete_list <- update_valid_alleles()
    }
    complete_list
}

# convert a allele into all possible alleles contained in this allele
# e.g. A*01:01 -> A*01:01:01, A*01:01:02, A*01:01:03
#' @title  Building a list of alleles to cover 
#' @description \code{build_allele_group} e.g. A*01:01 -> A*01:01:01, 
#' A*01:01:02, A*01:01:03
#'
#' @param allele_selection HLA allele for whicht
#' the allele group should be built.
#'
#' @return list of alleles
#' @export
#'
#' @examples
#' build_allele_group("A*01:01")
build_allele_group <- function(allele_selection) {
    # find all alleles that correspond to allele
    # get valid alleles
    valid_alleles <- get_valid_allele_list()
    
    # expand to alleles in the same p group
    p_group_name <- get_P_group(allele_selection)
    alleles_p_group <- get_p_group_members(p_group_name)
    
    # find alleles corresponding to selection
    valid_p_alleles <- intersect(union(
        stringr::str_replace(p_group_name, "P", ""), 
        alleles_p_group), valid_alleles)
    
    p_expand <- unlist(lapply(valid_p_alleles, function (X) {valid_alleles[
            # replace * by \\* to make the regexp work properly
            grepl(stringr::str_replace(X, "\\*", "\\\\*"), valid_alleles)]
        }))
    
    union(valid_p_alleles, union(unlist(p_expand), allele_selection))
}

# FUNCTIONS FOR ALLELE QUERY

assemble_url_allele_freq <- function(hla_locus,
    hla_selection, hla_population, hla_country, hla_region,
    hla_ethnic, hla_sample_size_pattern, hla_sample_size,
    standard, hla_locus_type = "Classical") {

    freq_url_root <- paste0("http://www.allelefrequencies.net/hla6006a.asp?",
    "hla_locus_type=%s&hla_locus=%s&hla_selection=%s&hla_population=%s&",
    "hla_country=%s&hla_dataset=&hla_region=%s&hla_ethnic=%s&hla_study=&",
    "hla_order=order_1&hla_sample_size_pattern=%s&",
    "hla_sample_size=%s&standard=%s")

    sprintf(freq_url_root, hla_locus_type,
        convert_string(hla_locus), convert_string(hla_selection),
        convert_string(hla_population), convert_string(hla_country),
        convert_string(hla_region), convert_string(hla_ethnic),
        convert_string(hla_sample_size_pattern),
        convert_string(hla_sample_size), standard)
}


#' Query allele frequencies
#'
#' @param hla_locus HLA locus that will be used for filtering data. A, B, C, 
#' DPA1, DPB1, DQA1, DQB1, DRB1
#' @param hla_selection Allele that will be used for filtering data. 
#' e.g. A*01:01
#' @param hla_population Numeric identifier of the population that will be used 
#' for filtering. This identifier is defined by the Allele Frequency 
#' Net Database.
#' @param hla_country Country of interest (e.g. Germany, France, ...).
#' @param hla_region Geographic region of interest 
#' (e.g. Europe, North Africa, ...)
#' @param hla_ethnic Ethnic origin of interest (e.g. Caucasoid, Siberian, ...)
#' @param hla_sample_size_pattern Keyword used to define the filtering for a 
#' specific population size. e.g. "bigger_than", "equal", "less_than", 
#' "less_equal_than", "bigger_equal_than"
#' @param hla_sample_size Integer number used to define the filtering for a 
#' specific population size, together with the hla_sample_size_pattern argument.
#' @param standard Population standards, as defined in the package vignette. 
#' "g" - gold, "s" - silver, "a" - all
#'
#' @return data.frame object containing the result of the allele frequency query
#' @export
#'
#' @examples
#'
#' # select frequencies of the A*02:01 allele,
#' # for gold standard population with more than 10,000 individuals
#' sel <- query_allele_frequencies(hla_selection = "A*02:01",
#' hla_sample_size_pattern = "bigger_than", hla_sample_size = 10000,
#' standard="g")
#'
query_allele_frequencies <- function(
    hla_locus = NA,
    hla_selection = NA,
    hla_population = NA,
    hla_country = NA,
    hla_region = NA,
    hla_ethnic = NA,
    hla_sample_size_pattern = NA,
    hla_sample_size = NA,
    standard = "a") {
    
    # check whether input parameters are valid
    verify_parameters(hla_locus = hla_locus, hla_selection = hla_selection,
        hla_population = hla_population, hla_country = hla_country,
        hla_region = hla_region, hla_ethnic = hla_ethnic,
        hla_sample_size_pattern = hla_sample_size_pattern,
        hla_sample_size = hla_sample_size, standard = standard,
        query_type ="allele")
    
    # maximum 20 alleles can be in the url (last length(hla_selection) 
    # because the last chunk missing)
    breaks <- c(seq(from = 0, to = length(hla_selection), by =19),
        length(hla_selection))
    
    # create empty data frame
    allele_df <- data.frame()
    for (i in seq(from = 1, to = length(breaks)-1)) {
    
        queryurl <- assemble_url_allele_freq(hla_locus,
            hla_selection[(breaks[i]+1):(breaks[i+1])], hla_population,
            hla_country, hla_region, hla_ethnic, hla_sample_size_pattern,
            hla_sample_size, standard)
        allele_df <- rbind(read_complete_freq_table(queryurl, type = "allele"),
            allele_df)
    }
    allele_df
}

# FUNCTIONS FOR HAPLOTYPES

assemble_haplotype_string_url_from_allele_list <- function(allele_list) {
    
    # this is the order in which loci need to be passed
    loci_regexp <- c("A\\*","B\\*","C\\*","DRB1\\*",
                        "DPA1\\*","DPB1\\*","DQA1\\*","DQB1\\*")
    # be default set to not include locus
    loci_names <- c("A_not", "B_not", "C_not", "DRB1_not", 
                        "DPA1_not", "DPB1_not", "DQA1_not", "DQB1_not")
    for (i in seq(length(loci_regexp))) {
        locus_name <- allele_list[grepl(loci_regexp[i], allele_list)]
        if (length(locus_name) > 1) {
            stop("In the list of haplotypes for the haplotype assembly, only",
            "one allele per locus may be passed. Following ",
            "entry causes conflict: ", locus_name)
        } else if (length(locus_name) != 0) {
            loci_names[i] <- locus_name
        }
    }
    hla_str <- sprintf(paste0("hla_locus1=%s&hla_locus2=%s&hla_locus3=%s&",
    "hla_locus4=%s&hla_locus5=%s&hla_locus6=%s&hla_locus7=%s&hla_locus8=%s"),
        loci_names[1], loci_names[2], loci_names[3],
        loci_names[4], loci_names[5], loci_names[6],
        loci_names[7], loci_names[8])
    hla_str
}
    

assemble_url_haplotype_freq <- function(hla_selection,
    hla_population, hla_country, hla_region, hla_ethnic,
    hla_sample_size_pattern, hla_sample_size) {
    
    hla_str <- assemble_haplotype_string_url_from_allele_list(hla_selection)
    freq_url_root <- stringr::str_c("http://www.allelefrequencies.net/",
    "hla6003x.asp?", hla_str, "&hla_population=%s&hla_country=%s&hla_dataset=&",
    "hla_region=%s&hla_ethnic=%s&hla_study=&hla_order=order_1",
    "&hla_sample_size_pattern=%s&hla_sample_size=%s&",
    "hla_sample_year_pattern=equal&hla_sample_year=&hla_loci=")
    
    sprintf(freq_url_root, 
        convert_string(hla_population), convert_string(hla_country),
        convert_string(hla_region), convert_string(hla_ethnic),
        convert_string(hla_sample_size_pattern), 
        convert_string(hla_sample_size))
}


#' Query haplotype frequencies
#'
#' @param hla_selection Alleles that will be used to build the haplotype query. 
#' One entry per locus. If no entry for a given locus, the function will search 
#' for haplotypes that do not include specifications for this locus. If any 
#' allele for a given locus should be considered, the list entry should be 
#' "A*" or other locus in same format.
#' @param hla_population Numeric identifier of the population that will be used 
#' for filtering. Thie identifier is defined by the Allele Frequency Net 
#' Database.
#' @param hla_country Country of interest (e.g. Germany, France, ...).
#' @param hla_region Geographic region of interest (e.g. Europe, 
#' North Africa, ...)
#' @param hla_ethnic Ethnic origin of interest (e.g. Caucasoid, Siberian, ...)
#' @param hla_sample_size_pattern Keyword used to define the filtering for a 
#' specific population size. e.g. "bigger_than", "equal", "less_than", 
#' "less_equal_than", "bigger_equal_than"
#' @param hla_sample_size Integer number used to define the filtering for a 
#' specific population size, together with the hla_sample_size_pattern argument.
#'
#' @return data.frame object containing the result of the allele frequency query
#' @export
#'
#' @examples
#' # works only for one haplotype at a time
#' query_haplotype_frequencies(hla_selection = c("A*02:01", "B*", "C*"), 
#' hla_region = "Europe")
#'
# only for one haplotype at a time
query_haplotype_frequencies <- function(
    # this selection is a selection of A,B,C.... alleles that will be assembled 
    # to haplotype
    hla_selection = NA,
    hla_population = NA,
    hla_country = NA,
    hla_region = NA,
    hla_ethnic = NA,
    hla_sample_size_pattern = NA,
    hla_sample_size = NA) {
    
    # check whether input parameters are valid
    verify_parameters(hla_locus = NA,
        hla_selection = hla_selection, hla_population = hla_population,
        hla_country = hla_country, hla_region = hla_region,
        hla_ethnic = hla_ethnic,
        hla_sample_size_pattern = hla_sample_size_pattern,
        hla_sample_size = hla_sample_size, query_type ="haplotype")

    queryurl <- assemble_url_haplotype_freq(hla_selection,
        hla_population, hla_country, hla_region, hla_ethnic,
        hla_sample_size_pattern, hla_sample_size)
    
    allele_df <- read_complete_freq_table(queryurl, type = "haplotype")
    allele_df
}

# FUNCTIONS FOR POPULATION QUERY

assemble_url_pop <- function(population_id) {

    pop_url_root <- "http://www.allelefrequencies.net/pop6001c.asp?pop_id=%s"

    sprintf(pop_url_root, population_id)
}

query_single_population_detail <- function(population_id) {
    check_population(population_id)
    pop_url <- assemble_url_pop(population_id)
    read_population_detail(pop_url, population_id)
}

#' Query population metainformation
#'
#' @param population_ids List of numeric identifiers of the population that 
#' will be used for filtering. The identifier is defined by the Allele 
#' Frequency Net Database.
#'
#' @return data.frame object containing the result of the population detail 
#' query
#' @export
#'
#' @examples
#' population_detail <- query_population_detail(0001986)
query_population_detail <- function(population_ids) {
    pop_df <- data.frame()
    for(pop_id in population_ids) {
        pop_df <- rbind(pop_df, query_single_population_detail(pop_id))
    }
    pop_df
}

context("Querying allele frequencies")

test_that("query_allele_frequencies() return error when arguments not adequate", {
    expect_error(query_allele_frequencies())
    expect_error(query_allele_frequencies(hla_locus = NA, 
        hla_selection = NA, hla_population = NA,
        hla_country = NA, hla_region = NA, hla_ethnic = NA,
        hla_sample_size_pattern = NA, hla_sample_size = NA,  standard = "a"))
    expect_error(query_allele_frequencies(hla_locus = "foo",
        hla_selection = NA, hla_population = NA,
        hla_country = NA, hla_region = NA, hla_ethnic = NA,
        hla_sample_size_pattern = NA, hla_sample_size = NA,  standard = "a"))
    expect_error(query_allele_frequencies(hla_locus = NA, 
        hla_selection = "foo", hla_population = NA,
        hla_country = NA, hla_region = NA, hla_ethnic = NA,
        hla_sample_size_pattern = NA, hla_sample_size = NA,  standard = "a"))
    expect_error(query_allele_frequencies(hla_locus = NA, 
        hla_selection = NA, hla_population = "foo",
        hla_country = NA, hla_region = NA, hla_ethnic = NA,
        hla_sample_size_pattern = NA, hla_sample_size = NA,  standard = "a"))
    expect_error(query_allele_frequencies(hla_locus = NA, 
        hla_selection = NA, hla_population = NA,
        hla_country = "foo", hla_region = NA, hla_ethnic = NA,
        hla_sample_size_pattern = NA, hla_sample_size = NA,  standard = "a"))
    expect_error(query_allele_frequencies(hla_locus = NA,
        hla_selection = NA, hla_population = NA,
        hla_country = NA, hla_region = "foo", hla_ethnic = NA,
        hla_sample_size_pattern = NA, hla_sample_size = NA,  standard = "a"))
    expect_error(query_allele_frequencies(hla_locus = NA, 
        hla_selection = NA, hla_population = NA,
        hla_country = NA, hla_region = NA, hla_ethnic = "foo",
        hla_sample_size_pattern = NA, hla_sample_size = NA,  standard = "a"))
    expect_error(query_allele_frequencies(hla_locus = NA, 
        hla_selection = NA, hla_population = NA,
        hla_country = NA, hla_region = NA, hla_ethnic = NA,
        hla_sample_size_pattern = "foo", hla_sample_size = NA,  standard = "a"))
        expect_error(query_allele_frequencies(hla_locus = NA, 
        hla_selection = NA, hla_population = NA,
        hla_country = NA, hla_region = NA, hla_ethnic = NA,
        hla_sample_size_pattern = NA, hla_sample_size = "foo",  standard = "a"))
    expect_error(query_allele_frequencies(hla_locus = NA,
        hla_selection = NA, hla_population = NA,
        hla_country = NA, hla_region = NA, hla_ethnic = NA,
        hla_sample_size_pattern = NA, hla_sample_size = NA,  standard = "foo"))
})

test_that("query_allele_frequencies() returns expected results", {
    sel1 <- query_allele_frequencies(hla_selection = "A*02:01", 
                                     hla_sample_size_pattern = "bigger_than", 
                                     hla_sample_size = 10000, 
                                     standard="g")
    expect_equal(ncol(sel1), 5)
})

context("Building overall allele groups")

test_that("build_allele_group() return error when arguments not adequate", {
    expect_error(build_allele_group())
    expect_error(build_allele_group("HLA01:01"))
    expect_error(build_allele_group("foo"))
    expect_error(build_allele_group("*"))
    expect_error(build_allele_group("DRB1*01"))
})

test_that("build_allele_group() returns expected results", {
    # this is not yet working
    expect_error(build_allele_group("A*01"))
    
    l1 <- build_allele_group("A*01:01")
    expect_is(l1, "character")
    expect_true(length(l1) > 3)
    
    l2 <- build_allele_group("A*01:01:01:01")
    expect_is(l2, "character")
    expect_true(length(l2) > 3)
    
    l3 <- build_allele_group("HLA-A*01:01")
    expect_is(l3, "character")
    expect_true(length(l3) > 3)
    
    l4 <- build_allele_group("DRB1*01:01:01")
    expect_is(l4, "character")
    expect_true(length(l4) > 3)
    
    l5 <- build_allele_group("HLA-DRB1*01:01:01")
    expect_is(l5, "character")
    expect_true(length(l5) > 3)
})
    
context("Querying haplotype frequency")

test_that("query_haplotype_frequencies() return error when arguments not adequate", {
    expect_error(query_haplotype_frequencies())
    expect_error(query_haplotype_frequencies(hla_selection = NA, 
                                    hla_population = NA, hla_country = NA,
                                    hla_region = NA, hla_ethnic = NA, 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = NA))
    expect_error(query_haplotype_frequencies(hla_selection = "foo", 
                                    hla_population = NA, hla_country = NA,
                                    hla_region = NA, hla_ethnic = NA, 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = NA))  
    expect_error(query_haplotype_frequencies(hla_selection = "", 
                                    hla_population = NA, hla_country = NA,
                                    hla_region = NA, hla_ethnic = NA, 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = NA)) 
    expect_error(query_haplotype_frequencies(hla_selection = "HLA-A", 
                                    hla_population = NA, hla_country = NA,
                                    hla_region = NA, hla_ethnic = NA, 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = NA)) 
    
    expect_error(query_haplotype_frequencies(hla_selection = NA, 
                                    hla_population = "foo", hla_country = NA,
                                    hla_region = NA, hla_ethnic = NA, 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = NA))
    expect_error(query_haplotype_frequencies(hla_selection = NA, 
                                    hla_population = NA, hla_country = "foo",
                                    hla_region = NA, hla_ethnic = NA, 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = NA))
    expect_error(query_haplotype_frequencies(hla_selection = NA, 
                                    hla_population = NA, hla_country = NA,
                                    hla_region = "foo", hla_ethnic = NA, 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = NA))
    expect_error(query_haplotype_frequencies(hla_selection = NA, 
                                    hla_population = NA, hla_country = NA,
                                    hla_region = NA, hla_ethnic = "foo", 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = NA))
    expect_error(query_haplotype_frequencies(hla_selection = NA, 
                                    hla_population = NA, hla_country = NA,
                                    hla_region = NA, hla_ethnic = NA, 
                                    hla_sample_size_pattern = "foo",
                                    hla_sample_size = NA))
    expect_error(query_haplotype_frequencies(hla_selection = NA, 
                                    hla_population = NA, hla_country = NA,
                                    hla_region = NA, hla_ethnic = NA, 
                                    hla_sample_size_pattern = NA,
                                    hla_sample_size = "foo"))
})

test_that("query_haplotype_frequencies() returns expected results", {
    df <- query_haplotype_frequencies(hla_selection = c("A*02:01", "B*", "C*"),
                                hla_region = "Europe")
    expect_equal(ncol(df), 5)
    
    expect_is(query_haplotype_frequencies(hla_selection = "A*01:01", 
                            hla_population = NA, hla_country = NA,
                            hla_region = NA, hla_ethnic = NA, 
                            hla_sample_size_pattern = NA,
                            hla_sample_size = NA), "data.frame")  
})


context("Plotting allele frequencies")

test_that("plot_allele_frequency() return error when arguments not adequate", {
    expect_error(plot_allele_frequency())
    
    # not behaving as expected
    expect_error(plot_allele_frequency(data.frame()))
})

test_that("plot_allele_frequency() returns expected results", {
    sel <- query_allele_frequencies(hla_selection = "A*02:01", 
                                    hla_sample_size_pattern = "bigger_than", 
                                    hla_sample_size = 10000, 
                                    standard="g")
    expect_is(plot_allele_frequency(sel), "ggplot")
})

context("Querying population details")

test_that("query_population_detail() return error when arguments not adequate", {
    expect_error(query_population_detail())
    expect_error(query_population_detail("foo"))
    expect_error(query_population_detail("3725"))
    
    # not behaving as expected
    expect_error(query_population_detail(1))
    expect_error(query_population_detail(c(1111)))
})

test_that("query_population_detail() returns expected results", {
    df <- query_population_detail(3725)
    expect_equal(ncol(df), 13)
    expect_equal(nrow(df), 1)
    expect_equal(df$population_id, 3725)
})

#' @importFrom rlang .data
#' @importFrom rlang .data
#' @keywords internal
assemble_frequency_lat_long_df <- function(global_alleles) {
    
    global_alleles$sample_size <- as.integer(
        stringr::str_remove_all(global_alleles$sample_size, pattern = ","))
    global_alleles$allele_frequency <- as.double(
        global_alleles$allele_frequency)
    
    global_alleles <- global_alleles[global_alleles$allele_frequency != 0.000,]
    global_alleles <- tidyr::drop_na(global_alleles)
    
    population_details <- query_population_detail(unique(as.numeric(
        global_alleles$population_id)))
    
    population_details <- tidyr::separate(population_details,
        .data$Latitude, into = c("lata", "mina", "dira"))
    population_details$lat <- ifelse(population_details$dira == "N",
        as.numeric(population_details$lata) + 
            as.numeric(population_details$mina)/60,
        -as.numeric(population_details$lata) -
            as.numeric(population_details$mina)/60)
    
    population_details <- tidyr::separate(population_details, .data$Longitude,
        into = c("longo", "mino", "diro"))
    population_details$long <- ifelse(population_details$diro == "E",
        as.numeric(population_details$longo) +
            as.numeric(population_details$mino)/60,
        -as.numeric(population_details$longo) -
            as.numeric(population_details$mino)/60)
    
    df_lat_long <- merge(global_alleles,
        population_details, by = "population_id")
    df_lat_long
}

#' @title Plotting allele frequencies
#' @description \code{plot_allele_frequency} Generate a World map 
#' displaying the frequency of a given table of HLA alleles. Use the function
#' \link{query_allele_frequencies} to generate a table with allele frequencies.
#'
#' @param allele_frequency returned by \link{query_allele_frequencies}
#'
#' @return ggplot2 object displaying the allele frequencies on a world map.
#' @export
#' @import maps
#' @importFrom rlang .data
#'
#' @examples
#' 
#' # select frequency of given allele
#' sel_allele_freq <- query_allele_frequencies(hla_selection = "A*02:01", 
#' hla_sample_size_pattern = "bigger_than", 
#' hla_sample_size = 10000, standard="g")
#' 
#' plot_allele_frequency(sel_allele_freq)
#' 
plot_allele_frequency <- function(allele_frequency) {
    
    df_lat_long <- assemble_frequency_lat_long_df(allele_frequency)
    
    WorldData <- ggplot2::map_data("world")[
        ggplot2::map_data("world")$region != "Antarctica",]
    
    ggplot2::ggplot() +
        ggplot2::geom_map(data = WorldData, map = WorldData,
            # removing x and y here makes the plot scale to the dots
            ggplot2::aes(group = .data$group, map_id = .data$region),
            fill = "darkgrey") +
        ggplot2::geom_point(data = df_lat_long,
            ggplot2::aes(x = as.numeric(.data$long),
                y = as.numeric(.data$lat),
                color = .data$allele_frequency), size = 5) +
        # scale x and y so that its uniform for all plots
        ggplot2::xlim(min(WorldData$long)+30, max(WorldData$long)-10) +
        ggplot2::ylim(min(WorldData$lat)+10, max(WorldData$lat)-10) +
        ggplot2::theme(legend.position=c(0.14,0.23),
            axis.title.x=ggplot2::element_blank(), 
            axis.title.y=ggplot2::element_blank())
}

#
#    Helper functions related to SINGLE CHAINS
#

# build strings for lookup of specific relationships
build_intersection <- function(MRO_ids_queried, type = c("has part",
    "gene product of")) {
    # find all entries that are "type"
    type_id <- mro.obo$id[mro.obo$name == type]
    # return as string which will be needed for lookup
    stringr::str_c(type_id, " ", MRO_ids_queried)
}

# build an intersection of two entry lists
find_intersection_ids <- function(intersection_list, int_list) {
    hits <- vapply(intersection_list, grep, x = int_list,
        FUN.VALUE = numeric(1))
    if (length(hits[[1]]) == 0) {hits <- NA}
    names(int_list)[hits]
}

# extract the sequence information for a given chain
extract_protein_sequence <- function(chain_list) {
    # build a recursion to extract for all chain ids
    proteins_seqs <- lapply(chain_list,
        function(X) {
            annot <- mro.obo$property_value[mro.obo$id == X][[1]]
            # for some chains no seq is given, this is why we have to 
            # test if character(0)
            if(length(annot) > 0) {
                prop_value <- annot[[3]]
                return(stringr::str_extract(prop_value,
                    "(?<=\\\")[A-Z]*(?=\\\")"))
            } else {return("")}
            }
    )
    proteins_seqs
}


#
#    Helper functions related to PROTEIN COMPLEX
#

# filter the molecules to only get complete molecules
filter_molecules <- function(subcomplex) {
    subcomplex[grep("complete molecule", mro.obo$property_value[subcomplex])]
}

# get all the descendant complexes to a given complex parent
# only return complete molecules
find_descendant_complexes <- function(complex_list) {
    subcomplexes <- lapply(
        complex_list, function(X) ontologyIndex::get_descendants(roots = X,
            ontology = mro.obo, exclude_roots = TRUE))
    names(subcomplexes) <- complex_list
    lapply(subcomplexes, filter_molecules)
}

# find if a molecule complex has complete or partial annotation
get_complex_status <- function(id) {
    prop_value <- ontologyIndex::get_term_property(mro.obo,
        property_name = "property_value", id, as_names = FALSE)
    # location of MRO:0001984
    loc_comp <- grep("MRO:0001984", prop_value)
    molecule_state <- strsplit(prop_value[loc_comp],
        split = "\\s\"|\"\\s")[[1]][[2]]
    # vapply expects character(1)
    as.character(molecule_state)
}

# return chains used by a given complex
get_complex_chains <- function(id) {
    prop_value <- ontologyIndex::get_term_property(mro.obo, 
        property_name = "intersection_of", id, as_names = FALSE)
    # location of MRO:0001984
    loc_comp <- grep("BFO:0000051", prop_value)
    chains <- stringr::str_extract(prop_value[loc_comp],
        pattern = "(?<=\\s)(.*)")
    chains
}

# return serotype used by a given complex
get_complex_serotype <- function(id) {
    prop_value <- ontologyIndex::get_term_property(mro.obo,
        property_name = "intersection_of", id, as_names = FALSE)
    loc_serotype <- grep("MRO:0000001", prop_value)
    serotype <- stringr::str_extract(prop_value[loc_serotype],
        pattern = "(?<=\\s)(.*)")
    if(length(serotype) == 0) {serotype <- as.character(NA)}
    serotype
}

#
# FUNCTIONS TO READ ALLELE AND HAPLOTYPE FREQUENCY DATA
#

#' get_nb_pages
#' @param page_tbl html input page
#' @return integer number of pages in the html input
#' @keywords internal
get_nb_pages <- function(page_tbl) {
    stringr::str_extract(page_tbl$X6, "\\d*$")
}

#' parse_allele_freq_html 
#' @description format the allele frequency table and select columns of interest
#' @param allele_freq_table allele frequency table parsed from AFND website
#' @return allele_freq_table reformatted
#' @keywords internal
parse_allele_freq_html <- function(allele_freq_table) {
    colnames(allele_freq_table) <- c("line", "allele", "", "population",
        "perc_individuals_with_allele",
        "allele_frequency", "", "sample_size")
    allele_freq_table[c("allele","population","allele_frequency","sample_size")]
} 

#' parse_haplotype_freq_html 
#' @description format the haplotype frequency table and select 
#' columns of interest
#' @param haplotype_freq_table haplotype frequency table parsed
#' from AFND website
#' @return haplotype_freq_table reformatted
#' @keywords internal
parse_haplotype_freq_html <- function(haplotype_freq_table) {
    colnames(haplotype_freq_table) <- c("line", "haplotype", "", "population", 
        "perc_individuals_with_haplotype",
        "", "sample_size", "")
    haplotype_freq_table[c("haplotype","population",
        "perc_individuals_with_haplotype","sample_size")]
}

#' extract_population_id 
#' @description extract the population ids from the html result
#' @param data html from AFND website
#' @return population ids
#' @keywords internal
extract_population_id <- function(data) {
    pop_hrefs <- rvest::html_attr(
        rvest::html_nodes(
            rvest::html_nodes(data, "td:nth-child(4)"), "a"), "href")
    # on page > 1 there is another href on top and below
    filtered_pop_hrefs <- pop_hrefs[grep("pop6001", pop_hrefs)]
    stringr::str_extract(filtered_pop_hrefs , "\\d\\d\\d\\d$")
}

#' read_complete_freq_table 
#' @param url URL of the website containing frequency table
#' @param type ["allele"|"haplotype"] 
#' @return frequency table
#' @keywords internal
read_complete_freq_table <- function(url, type) {
    html_input <- getURL(url, read_method = "html")
    
    rvest_tables <- rvest::html_table(html_input, fill = TRUE)
    
    output_table <- data.frame()
    # get the number of pages that need to be read
    # for some instances where no entries found,the page number is no indicated 
    # return empty table in this case
    if(length(rvest_tables) > 3) {
        page_nb <- as.numeric(get_nb_pages(rvest_tables[[4]]))
    } else {return(output_table)}
    
    if (length(page_nb) != 0) {
        # for 1-n pages query the allele frequencies
        for (page_id in seq(page_nb)) {
            url_tmp <- paste0(url, "&page=", 
                as.character(page_id), collapse = "")
            html_input_tmp <- getURL(url_tmp, read_method = "html")
            rvest_tables_tmp <- rvest::html_table(html_input_tmp, fill = TRUE)
            # add the population ID
            pop_ids <- extract_population_id(html_input_tmp)
            if (type == "allele") {
                freq_table <- parse_allele_freq_html(rvest_tables_tmp[[5]])
            } else if (type == "haplotype") {
                freq_table <- parse_haplotype_freq_html(rvest_tables_tmp[[5]])
            }
            
            freq_table$population_id <- pop_ids
            
            output_table <- rbind(output_table, freq_table)
        }
    }
    # return the final output table
    output_table
}

#
# FUNCTIONS TO READ POPULATION DETAILS
#

#' extract_population_name
#' @param data html input page
#' @return population name
#' @keywords internal
extract_population_name <- function(data) {
    rvest::html_text(
        rvest::html_nodes(data, xpath = "//td//h1"),
        trim = TRUE)
}

#' extract_population_info
#' @param data html input page
#' @return population information
#' @keywords internal
extract_population_info <- function(data) {
    raw_pop_data <- rvest::html_table(
        rvest::html_nodes(data, ".table04:nth-child(4)"),
        fill = TRUE)[[1]]
    # reformat in a key value manner
    key_names <- stringr::str_replace(
        raw_pop_data$X2[3:nrow(raw_pop_data)], ":",
        "")
    values <- raw_pop_data$X3[3:nrow(raw_pop_data)]
    
    names(values) <- key_names
    values
}

#' extract_sample_info
#' @param data html input page
#' @return sample information
#' @keywords internal
extract_sample_info <- function(data) {
    raw_sample_data <- rvest::html_table(
        rvest::html_nodes(data, ".table04:nth-child(6)"),
        fill = TRUE)[[1]][seq(8),]
    # reformat in a key value manner
    key_names <- stringr::str_replace(
        raw_sample_data$X2[3:nrow(raw_sample_data)], ":",
        "")
    values <- raw_sample_data$X3[3:nrow(raw_sample_data)]
    
    names(values) <- key_names
    values
}

#' read_population_detail
#' @param url url of the page containing population information
#' @param population_id numeric population identifier
#' @return population information
#' @keywords internal
read_population_detail <- function(url, population_id) {
    data <- getURL(url, read_method = "html")
    
    # Population
    population_name <- extract_population_name(data)
    
    # Population data
    pop_data <- extract_population_info(data)
    
    # sample data
    sample_data <- extract_sample_info(data)
    
    # Assemble into a data frame
    # one row with all info in columns
    data.frame(population_id = population_id,
        t(pop_data),
        t(sample_data), stringsAsFactors = FALSE)
}

#
# INPUT VALIDATION FUNCTIONS
#

#' check_hla_locus, stops if input not adequate
#' @param hla_locus locus of hla frequencies to query
#' @return TRUE
#' @keywords internal
check_hla_locus <- function(hla_locus) {
    if (is.na(hla_locus)) {TRUE} else {
        # classical HLA loci
        valid_hla_loci <- c("A","B","C",
                            "DPA1", "DPB1", "DQA1", "DQB1", "DRB1")
        if (hla_locus %in% valid_hla_loci) {
            TRUE
        } else {
            stop("The hla_locus ", hla_locus, 
                " does not belong to the list of valid HLA loci: ",
                paste(valid_hla_loci, collapse=",")) 
        }}
}

#' check_hla_selection, stops if input not adequate
#' @param hla_selection HLA alleles used for selection
#' @param query_type ["allele"|"haplotype"] type of AFND query
#' @return TRUE
#' @keywords internal
check_hla_selection <- function(hla_selection, query_type) {
    if (any(is.na(hla_selection))) {TRUE} else {
        # we do not check whether the indicated allele is in the database
        # we just check general formatting
        # hla_selection can be a list of alleles
        if (query_type == "allele") {
            # for alleles at least A*01 level is required
            pattern_match <- grepl("^(\\w*|\\w*\\d)\\*\\d\\d", hla_selection)
        } else if (query_type == "haplotype") {
            # for haplotype A* level is ok to query any HLA-A allele
            pattern_match <- grepl("^(\\w*|\\w*\\d)\\*", hla_selection)  
        } else {stop("query_type must be allele or haplotype")}
        
        if (all(pattern_match)) {
            TRUE
        } else {
            wrong_allele <- hla_selection[!pattern_match]
            stop("The following alleles do not seem to be formated correctly ",
            "(expected format e.g. A*01:01): ",
                paste(wrong_allele, collapse=","))
        }}
}

#' check_population, stops if input not adequate
#' @param hla_population population id
#' @return TRUE
#' @keywords internal
check_population <- function(hla_population) {
    if (is.na(hla_population)) {TRUE} else {
        # We just check formatting
        # we do not check whether this population actually exists
        # format seems to be 4 numbers, but it has to be formatted as numeric
        pattern_match <- vapply(hla_population, is.numeric, 
            FUN.VALUE = logical(1))
        if (all(pattern_match)) {
            TRUE
        } else {
            wrong_pop <- hla_population[!pattern_match]
            stop("The following population IDs do not seem to be formated ",
            "correctly (expected format e.g. 1920): ",
                paste(as.character(wrong_pop), collapse=","))
        }}
}


#' get_valid_geographics
#' @description get a list of valid countries, regions and ethnic origins
#' @return list of valid countries, regions and ethnic origin
#' @keywords internal
get_valid_geographics <- function() {
    url <- "http://www.allelefrequencies.net/hla6006a.asp?"
    html_input <- getURL(url, read_method = "html")
    
    rvest_tables <- rvest::html_table(html_input, fill = TRUE)
    
    # country
    selection_str_1 <- rvest_tables[[3]]$X1[[5]]
    split_selection_str_1 <- stringr::str_split(selection_str_1,
        "(\r\n\t\t\t\t\t)|(\r\n)|(\n)|(\n\t\t\t\t\t)")[[1]]
    
    valid_countries <- stringr::str_split(split_selection_str_1[[4]],
        pattern = stringr::regex("(?<=[a-z]|\\))(?=[A-Z])"))[[1]]
    
    # region, ethnic
    selection_str_2 <- rvest_tables[[3]]$X1[[6]]
    split_selection_str_2 <- stringr::str_split(selection_str_2,
        "(\r\n\t\t\t\t\t)|(\r\n)|(\n)|(\n\t\t\t\t\t)")[[1]]
    
    valid_regions <- stringr::str_split(split_selection_str_2[[2]],
        pattern = stringr::regex("(?<=[a-z])(?=[A-Z])"))[[1]]
    
    valid_ethnic <- stringr::str_split(split_selection_str_2[[4]], 
        pattern = stringr::regex("(?<=[a-z])(?=[A-Z])"))[[1]]
    
    list(valid_countries = valid_countries,
        valid_regions = valid_regions,
        valid_ethnic = valid_ethnic)
}

valid_geographics <- get_valid_geographics()

#' check_geographics, stops if input not adequate
#' @param country country used for allele frequency selection
#' @param region geographical region used for allele frequency selection
#' @param ethnic ethical origin used for allele frequency selection
#' @return TRUE
#' @keywords internal
check_geographics <- function(country, region, ethnic) {
    # do not test is its na
    if (!is.na(country)) {
        if(!(country %in% valid_geographics$valid_countries)) {
            stop("Country not part of valid countries list: ", country,
                ". Valid list of countries is: ", 
                paste(valid_geographics$valid_countries, collapse = ", "))
        }
    }
    if (!is.na(region)) {
        if(!(region %in% valid_geographics$valid_regions)) {
            stop("Region not part of valid regions list: ", region, 
                ". Valid list of regions is: ", 
                paste(valid_geographics$valid_regions, collapse = ", "))
        }
    }
    if (!is.na(ethnic)) {
        if(!(ethnic %in% valid_geographics$valid_ethnic)) {
            stop("Ethnic origin not part of valid regions list: ", ethnic, 
                ". Valid list of ethnics origin is: ", 
                paste(valid_geographics$valid_ethnic, collapse = ", "))
        }
    }
}

#' check_sample_size, stops if input not adequate
#' @param hla_sample_size_pattern one of "bigger_than", "equal", "less_than", 
#' "less_equal_than", "bigger_equal_than","different"
#' @param hla_sample_size integer number used for population size
#' @return TRUE
#' @keywords internal
check_sample_size <- function(hla_sample_size_pattern, hla_sample_size) {
    if (is.na(hla_sample_size_pattern) & is.na(hla_sample_size)) {TRUE} else {
        valid_pattern <- c("bigger_than",
            "equal", "less_than",
            "less_equal_than", "bigger_equal_than", "different")
        
        if (hla_sample_size_pattern %in% valid_pattern) {
            if (is.numeric(hla_sample_size)) {TRUE}
            else { stop("hla sample size must be numeric") }
        } else {
            stop("The hla_sample_size_pattern must be one of these options: ",
                paste(valid_pattern, collapse=","))
        }}
}

#' check_standard, stops if input not adequate
#' @param standard one of "a" - all,"s" - silver,"g" - gold
#' @return TRUE
#' @keywords internal
check_standard <- function(standard) {
    # all, silver or gold standard of population data quality
    valid_standard <- c("a","s","g")
    if(standard %in% valid_standard) {
        TRUE
    } else { stop("standard must be one of the following: ",
        paste(valid_standard, collapse=",") )}
}


#' verify_parameters
#'
#' @param hla_locus locus of hla frequencies to query
#' @param hla_selection HLA alleles used for selection
#' @param hla_population population id
#' @param hla_country country used for allele frequency selection
#' @param hla_region geographical region used for allele frequency selection
#' @param hla_ethnic ethical origin used for allele frequency selection
#' @param hla_sample_size_pattern one of "bigger_than", "equal", "less_than", 
#' "less_equal_than", "bigger_equal_than","different"
#' @param hla_sample_size integer number used for population size
#' @param standard  one of "a" - all,"s" - silver,"g" - gold
#' @param query_type "allele" or "haplotype"
#'
#' @return boolean to indicate, whether tests were passed
#' @keywords internal
verify_parameters <- function(hla_locus,
                            # for now we don't check the 
                            hla_selection,
                            hla_population,
                            hla_country,
                            hla_region,
                            hla_ethnic,
                            hla_sample_size_pattern,
                            hla_sample_size,
                            standard = "a",
                            query_type) {
    
    # do the checks only if variables are not na
    if (all(is.na(c(hla_locus, hla_selection, hla_population,
        hla_sample_size_pattern, hla_sample_size)))) {
        stop("You need to at least specify one of the paramters hla_locus, ",
        "hla_selection, hla_population, hla_sample_size_pattern, ",
        "hla_sample_size.")
    } else {
        # do the checks only if variables are not na
        all(check_standard(standard),
            check_sample_size(hla_sample_size_pattern, hla_sample_size),
            check_population(hla_population),
            check_geographics(hla_country, hla_region, hla_ethnic),
            check_hla_selection(hla_selection, query_type),
            check_hla_locus(hla_locus))
    }
}

#
# MRO
#

#' load_mro 
#' @return MRO in ontology_index format
#' @keywords internal
load_mro <- function() {
    obo_file_name <- system.file("extdata", "mro.obo.gz",
        package = "immunotation")
    
    mro.obo <- ontologyIndex::get_OBO(obo_file_name,
        extract_tags="everything")
    
    mro.obo
}

#' @title MRO
#' @description   \code{mro.obo}: MHC Restriction Ontology obo file.
#' @keywords internal
mro.obo <- load_mro()


#
#   Reading URLs
#

#' getURL
#'
#' @param URL  Indicated the url that will be read
#' @param N.TRIES   Integer, how often should the function try to read the URL?
#' @param read_method Method to be used for reading of URL content 
#' ("delim" -> \code{readr::read_delim}, 
#' "lines" -> \code{readr::read_lines}, "html" -> \code{xml2::read_html})
#' @param skip integer indicating how many lines to skip when reading URL 
#' @param delim pattern used for delim 
#' (passed to \code{delim} of read functions)
#' @param col_names list of colnames to use
#'
#' @return returns a the content of the URL. The format of the return object
#' depends on the read_method that was used.
#' @keywords internal
getURL <- function(URL, N.TRIES=2L, 
    read_method = c("delim", "lines", "html"),
    skip = 0, delim = "\t", col_names = TRUE) {
    N.TRIES <- as.integer(N.TRIES)
    stopifnot(length(N.TRIES) == 1L, !is.na(N.TRIES))
    while (N.TRIES > 0L) {
        if (read_method == "delim") {
            result <- tryCatch(suppressMessages(readr::read_delim(URL,
                delim = delim, skip = skip, col_names = col_names)),
                error=identity)
        } else if (read_method == "lines") {
            result <- tryCatch(readr::read_lines(URL), error=identity)
        } else if (read_method == "html") {
            result <- tryCatch(xml2::read_html(URL), error=identity)
        } else {stop("Read method unknown")}
        
        if (!inherits(result, "error"))
            break
        N.TRIES <- N.TRIES - 1L
    }
    if (N.TRIES == 0L) {
        stop("'getURL()' failed:",
            "\n  URL: ", URL, "\n  error: ", conditionMessage(result))
    }
    result
}

#
#   NetMHC input
#

# MHC I
# netmhcI_input_template is an internal variable containing list of valid 
# NetMHCpan input alleles
netmhcI_input_template <- getURL(
    URL="https://services.healthtech.dtu.dk/services/NetMHCpan-4.1/allele.list",
    read_method = "delim", delim = "\t",
    col_names = c("netmhc_input", "hla_chain_name", "HLA_gene"))

# MHC II
lines <- getURL(
    URL = paste0("https://services.healthtech.dtu.dk/services/",
    "NetMHCIIpan-4.0/alleles_name.list"),
    read_method = "lines")
lines_rep <- stringr::str_replace_all(lines, "\t+|\\s\\s+", "\t")
netmhcII_input_template <- suppressWarnings(
    suppressMessages(read.delim(textConnection(lines_rep), sep = "\t")))


all_netmhcII_template <- c(netmhcII_input_template$DR, 
    netmhcII_input_template$DP.alpha, netmhcII_input_template$DP.beta,
    netmhcII_input_template$DQ.alpha, netmhcII_input_template$DQ.beta)
# all_netmhcII_template is an internal variable containing list of valid 
# NetMHCIIpan input alleles
all_netmhcII_template <- unique(all_netmhcII_template[!is.na(all_netmhcII_template)])


#
# G and P groups
#

#' get_external_file
#'
#' @param file  Indicated the file that will be read
#' @param skip integer indicating how many lines to skip when reading URL 
#' @param delim pattern used for delim 
#' (passed to \code{delim} of read functions)
#' @param col_names list of colnames to use
#'
#' @return returns a the content of the file. The format of the return object
#' depends on the read_method that was used.
#' @keywords internal
get_external_file <- function(file, skip = 0, delim = "\t", col_names = TRUE) {
    result <- tryCatch(suppressMessages(readr::read_delim(file,
            delim = delim, skip = skip, col_names = col_names)),
            error=identity)
    if (!inherits(result, "error")) {
        return(result)
    }
    else {
        stop("'get_external_file()' failed:",
            "\n  file: ", file, "\n  error: ", conditionMessage(result))
    }
}

# G group
# wget https://raw.githubusercontent.com/ANHIG/IMGTHLA/Latest/wmda/hla_nom_g.txt
g_group <- get_external_file(file = system.file("extdata", "hla_nom_g.txt",
        package = "immunotation"),
    skip = 6, delim = ";", 
    col_names = c("locus", "g_group", "g_group_name"))
g_group$locus <- stringr::str_extract(g_group$locus,
    pattern = "[:alnum:]+(?=\\*?)")


# P group
# wget https://raw.githubusercontent.com/ANHIG/IMGTHLA/Latest/wmda/hla_nom_p.txt
p_group <- get_external_file(file = system.file("extdata", "hla_nom_p.txt",
        package = "immunotation"),
    skip = 6, delim = ";", 
    col_names = c("locus", "p_group", "p_group_name"))
p_group$locus <- stringr::str_extract(p_group$locus,
    pattern = "[:alnum:]+(?=\\*?)")

context("Reading input file utilities")

test_that("getURL() returns an error on an invalid URL", {
    expect_error(getURL(URL = "https://iamnotanurl", read_method = "delim"))
    expect_error(getURL(URL = "https://iamnotanurl", read_method = "lines"))
    expect_error(getURL(URL = "https://iamnotanurl", read_method = "html"))
})

test_that("getURL() returns an error when the arguments are not matching", {
    expect_error(getURL(URL = "https://services.healthtech.dtu.dk/services/NetMHCpan-4.1/allele.list", 
                        read_method = "iamnotamethod"))
    expect_error(getURL(URL = "https://services.healthtech.dtu.dk/services/NetMHCpan-4.1/allele.list", 
                        read_method = "delim", delim = TRUE))
})


context("External input of MRO ontology")

test_that("load_mro() returns a valid ontology", {
    expect_true(ontologyIndex::check(load_mro()))
})

context("NetMHC valid allele lists")

test_that("netmhcI_input_template has the right column types", {
    # This can be updated
    expect_equal(ncol(netmhcI_input_template), 3)
    expect_is(netmhcI_input_template$netmhc_input, "character")
    expect_is(netmhcI_input_template$hla_chain_name, "character")
})

test_that("netmhcI_input_template has adequate entries", {
    expect_true("HLA-A01:01" %in% netmhcI_input_template$netmhc_input)
    expect_true("HLA-A*01:01" %in% netmhcI_input_template$hla_chain_name)
})

test_that("all_netmhcII_template has adequate entries", {
    # check that there are entries for every expected locus
    patterns_loci <- c("DRB1*", "DRB3*", "DRB4*", "DRB5*", 
                       "DPA1*", "DPB1*", "DQA1*", "DQB1*")
    observed_loci <- unique(stringr::str_extract(all_netmhcII_template, 
                                                 "^\\w+\\*"))
    common_loci <- intersect(patterns_loci, observed_loci)
    expect_equal(length(common_loci), 8)
    
    # check that a exemplary allele is present
    expect_true("DRB1*01:03" %in% all_netmhcII_template)
})

context("G and P groups external sources")

test_that("g_groups has the right column types", {
    expect_equal(ncol(g_group), 3)
    expect_is(g_group$locus, "character")
    expect_is(g_group$g_group, "character")
    expect_is(g_group$g_group_name, "character")
})

test_that("g_groups has all expected loci", {
    patterns_loci <- c("A","B","C","DPA1","DPB1","DQA1",
                       "DQB1","DRB1","DRB3","DRB4","DRB5")
    observed_loci <- unique(g_group$locus)
    common_loci <- intersect(patterns_loci, observed_loci)
    expect_equal(length(common_loci), 11)
})

test_that("g_groups has expected entries", {
    expect_true("01:01:01G" %in% g_group$g_group_name)
    expect_true("01:03:01:01/01:03:01:02/01:03:02/01:287N/01:315" %in% 
                    g_group$g_group)
})

test_that("p_groups has the right column types", {
    expect_equal(ncol(p_group), 3)
    expect_is(p_group$locus, "character")
    expect_is(p_group$p_group, "character")
    expect_is(p_group$p_group_name, "character")
})

test_that("p_groups has all expected loci", {
    patterns_loci <- c("A","B","C","DPA1","DPB1","DQA1",
                       "DQB1","DRB1","DRB3","DRB4","DRB5")
    observed_loci <- unique(p_group$locus)
    common_loci <- intersect(patterns_loci, observed_loci)
    expect_equal(length(common_loci), 11)
})

test_that("p_groups has expected entries", {
    expect_true("01:01P" %in% p_group$p_group_name)
    expect_true("01:03:01:01/01:03:01:02/01:03:02/01:315" %in% p_group$p_group)
})

#' @title Get format for NetMHCpan tools
#' @description NetMHCpan tools for MHC-peptide binding prediction require 
#' HLA complex names in a specific format. \code{get_mhcpan_input} formats a 
#' list of HLA alleles into a list of NetMHC-formated complexes.
#'
#' @param allele_list list of HLA alles (e.g. c("A*01:01:01","B*27:01"))
#' @param mhc_class ["MHC-I"|"MHC-II"] indicated which NetMHC you want to use.
#'
#' @return protein chain list as formatted for MHCpan input
#' @export
#'
#' @examples
#' allele_list <- c("A*01:01:01","B*27:01")
#' get_mhcpan_input(allele_list, mhc_class = "MHC-I")
get_mhcpan_input <- function(allele_list, mhc_class) {
    # convert to locus*dd:dd format
    protein_chain_names <- reformat_allele(allele_list)
    
    # convert to MHCpan naming scheme
    if(mhc_class == "MHC-I") {
        # convert to MHCpanI format: HLA-A01:01
        # since there is only one chain this is easy
        mhc_name_list <- vapply(protein_chain_names, convert_naming,
            add_hla = TRUE, add_star = FALSE,
            FUN.VALUE = character(1))
        # check that they are allowed in the MHC input
        valid_in_reference <- vapply(mhc_name_list, function(x) x %in%
                netmhcI_input_template$netmhc_input, FUN.VALUE = logical(1))
        if (!all(valid_in_reference)) {stop(mhc_name_list[!valid_in_reference], 
            " not in NetMHCpan input list.\n")}
        mhc_name_list <- mhc_name_list[valid_in_reference]
    } else if (mhc_class == "MHC-II") {
        # check which chains belong together
        # convert to NetMHCIIpan format: HLA-DPA10103-DPB10101
        mhc_name_list <- build_mhcII_complexes(protein_chain_names)
    } else {stop("mhc_class schould be MHC-I or MHC-II.")}
    # names should not appear, because the complexes for mhc-ii are 
    # composed of different elements of the original list
    names(mhc_name_list) <- NULL
    mhc_name_list
}

build_mhcII_complexes <- function(protein_chain_names) {
    # check what is present
    valid_in_reference <- vapply(protein_chain_names, function(x) x %in% 
            all_netmhcII_template, FUN.VALUE = logical(1))
    # check if there are DRA alleles 
    # (they are not relevant in the netmhciipan list)
    valid_in_reference <- valid_in_reference | grepl("DRA", protein_chain_names)
    
    if(!all(valid_in_reference)) {
        stop(protein_chain_names[!valid_in_reference],
            " not in NetMHCIIpan input list.\n")
    }

    protein_chain_names_valid <- protein_chain_names[valid_in_reference]       
    
    # DPA1 DPB1
    dp_complexes <- assemble_dp_dq(protein_chain_names_valid, type = "DP")
    dp_complexes <- stringr::str_replace(dp_complexes, " ", "-")
    # DQA1 DQB1
    dq_complexes <- assemble_dp_dq(protein_chain_names_valid, type = "DQ")
    dq_complexes <- stringr::str_replace(dq_complexes, " ", "-")
    # DRA DRB
    drb <- protein_chain_names_valid[grep("DRB", protein_chain_names_valid)]
    drb <- vapply(drb, convert_naming, add_hla = FALSE,
        add_star = TRUE, remove_colon = TRUE, star = "_",
        FUN.VALUE = character(1))
    c(drb, dq_complexes, dp_complexes)
}

assemble_dp_dq <- function(protein_chain_names, type = c("DP", "DQ")) {
    if (type == "DP") {
        alpha <- "DPA1"; beta <- "DPB1"
    } else if (type == "DQ") {
        alpha <- "DQA1"; beta <- "DQB1"
    } else {stop("type needs to be DP or DQ")}
    
    alpha_names <- protein_chain_names[grep(alpha, protein_chain_names)]
    alpha_names <- vapply(alpha_names, convert_naming, add_hla = TRUE,
        add_star = FALSE, remove_colon = TRUE,
        FUN.VALUE = character(1))
    beta_names <- protein_chain_names[grep(beta, protein_chain_names)]
    beta_names <- vapply(beta_names, convert_naming, add_hla = FALSE,
        add_star = FALSE, remove_colon = TRUE,
        FUN.VALUE = character(1))
    dpb_complexes <- unlist(as.list(outer(alpha_names, beta_names, paste)))
    
    dpb_complexes
}

convert_naming <- function(name, add_hla = TRUE, add_star = TRUE,
            remove_colon = FALSE, star = "*") {
    hla_prefix <- ""
    if (add_hla) {hla_prefix <- "HLA-"}
    if (!add_star) {star <- ""}
    locus_allele <- stringr::str_split(name, pattern = "\\*")[[1]]
    locus <- locus_allele[[1]]
    number <- locus_allele[[2]]
    if (remove_colon) {number <- stringr::str_replace(number, ":", "")}
    paste0(hla_prefix, locus, star, number)
}

simplify_allele <- function(name_list, from_format = NA, to_format = NA) {
    gene_group_list <- vapply(name_list, derive_gene_group,
        FUN.VALUE = character(1))
    # match to P group
    # manually extract the right formatting
    protein_chain_list <- vapply(gene_group_list, reformat_allele,
        FUN.VALUE = character(1))
    protein_chain_list
}

reformat_allele <- function(allele_name) {
    simplified_allele <- stringr::str_extract(allele_name, 
                                pattern = "^[:alnum:]+\\*\\d+:\\d+")
    if (any(is.na(simplified_allele))) {
        # check if maybe HLA formatting is used
        simplified_allele <- stringr::str_extract(allele_name, 
                                pattern = "(?<=HLA-)[:alnum:]+\\*\\d+:\\d+")
        if (any(is.na(simplified_allele))) { 
            stop("Input allele does not have the right formating: ", 
                    allele_name[is.na(simplified_allele)]) }
    }
    simplified_allele
}

allele_name_sanity_check <- function(allele_name) {
    allele_name_old <- allele_name
    hla_string <- grepl("HLA-", allele_name)
    if (hla_string) {
        # remove the HLA prefix
        allele_name <- stringr::str_replace(allele_name, "HLA-", "")
    }
    # check if * : pattern contained
    valid <- grepl("^.+\\*\\d+:\\d+", allele_name)
    if (!valid) {stop("Input allele does not have the right formating: ",
        allele_name_old)}
    allele_name 
}

derive_gene_group <- function(allele_name) {
    allele_name <- allele_name_sanity_check(allele_name)
    locus_allele <- stringr::str_split(allele_name, pattern = "\\*")[[1]]
    locus <- locus_allele[[1]]
    allele <- locus_allele[[2]]
    
    locus_g_group <- g_group[g_group$locus == locus,]
    # check if can be found in database
    reg_expression_group <- paste0("/",allele,"/|^",allele,"/|/",allele,"$")
    match_position <- grep(reg_expression_group,locus_g_group$g_group)
    
    # if not found, search in gene group
    if (length(match_position) == 0) {
        reg_expression_name <- paste0("^",allele,"G")
        match_position <- grep(reg_expression_name,locus_g_group$g_group_name)
    }
    # if nothing found, keep original allele name
    if (length(match_position) == 0) {
        g_group_return <- allele_name
    } else {
        g_group_name <- unique(locus_g_group$g_group_name[match_position])
        g_group_return  <- paste0(locus,"*",g_group_name)      
    }
    g_group_return 
}

#' @title G groups
#' 
#' @description Get the G groups for a list of HLA alleles. 
#' [G groups](http://hla.alleles.org/alleles/g_groups.html) are groups of 
#' HLA alleles that have identical nucleotide sequences across the exons 
#' encoding the peptide binding domains.
#'
#' @param allele_list List of alleles.
#'
#' @return Named list of G-groups the input alleles belong to.
#' @export
#'
#' @examples
#' allele_list <- c("DQB1*02:02:01", "DQB1*06:09:01")
#' get_G_group(allele_list)
#' 
get_G_group <- function(allele_list) {
    vapply(allele_list, derive_gene_group,
        FUN.VALUE = character(1))
}

derive_protein_group <- function(allele_name) {
    allele_name <- allele_name_sanity_check(allele_name)
    locus_allele <- stringr::str_split(allele_name, pattern = "\\*")[[1]]
    locus <- locus_allele[[1]]
    allele <- locus_allele[[2]]
    
    locus_p_group <- p_group[p_group$locus == locus,]
    # check if can be found in database
    reg_expression_group <- paste0("/",allele,"/|^",allele,"/|/",allele,"$")
    # if the allele is given at a xx:xx:xx level, also allow for further 
    # matching to /01:03:01:xx/|^01:03:01:xx/|/01:03:01:xx
    # this is necessary because a lot of alleles in p group file are given at 
    # the xx:xx:xx:xx level
    if(stringr::str_count(allele_name, ":") > 1 ) {
        add_regexp_group <- paste0("|/",allele,":|^",allele,":")
        reg_expression_group <- paste0(reg_expression_group, add_regexp_group)
    }
    match_position <- grep(reg_expression_group,locus_p_group$p_group)
    
    # if not found, search in gene group
    if (length(match_position) == 0) {
        reg_expression_name <- paste0("^",allele,"P")
        match_position <- grep(reg_expression_name,locus_p_group$p_group_name)
    }
    # if nothing found, keep original allele name
    if (length(match_position) == 0) {
        p_group_return <- allele_name
    } else {
        p_group_name <- unique(locus_p_group$p_group_name[match_position])
        p_group_return  <- paste0(locus,"*",p_group_name)      
    }
    p_group_return
}

# get p group elements
get_p_group_members <- function(p_group_name) {
    p_group_name <- allele_name_sanity_check(p_group_name)
    locus_allele <- stringr::str_split(p_group_name, pattern = "\\*")[[1]]
    locus <- locus_allele[[1]]
    allele <- locus_allele[[2]]
    p_group_selection <- p_group[p_group$locus == locus &
            !is.na(p_group$p_group_name),]
    return_list <- p_group_selection$p_group[
        p_group_selection$p_group_name == allele]
    if(length(return_list) == 0) {return(p_group_name)} else {
        return_list <- stringr::str_split(return_list, pattern = "/")[[1]]
        return_list <- stringr::str_c(locus,"*",return_list)
        return(return_list)}
}

#' @title P groups
#' 
#' @description Get the P groups for a list of HLA alleles. 
#' [P groups](http://hla.alleles.org/alleles/p_groups.html) are groups 
#' of HLA alleles that have identical protein sequences in the peptide binding 
#' domains.
#'
#' @param allele_list list of HLA alleles
#'
#' @return Named list of P-groups the input alleles belong to.
#' @export
#'
#' @examples
#' allele_list <- c("DQB1*02:02:01", "DQB1*06:09:01")
#' get_P_group(allele_list)
#' 
get_P_group <- function(allele_list) {
    vapply(allele_list, derive_protein_group,
        FUN.VALUE = character(1))
}

context("P and G groups")

test_that("get_G_group() and get_P_group() return error when arguments not adequate", {
    expect_error(get_G_group("foo"))
    expect_error(get_P_group("foo"))
    expect_error(get_G_group("*"))
    expect_error(get_P_group("*"))
    expect_error(get_G_group("HLA-A*"))
    expect_error(get_P_group("HLA-A*"))
})

test_that("get_G_group() and get_P_group() return expected results", {
    # this should return something else
    expect_equal(get_G_group("HLA-A*01:01:01:01")[[1]], "A*01:01:01G")
    expect_equal(get_G_group("A*01:01:01:01")[[1]], 
                 get_G_group("HLA-A*01:01:01:01")[[1]])
    expect_equal(get_G_group("DQB1*02:02:01")[[1]], 
                 get_G_group("HLA-DQB1*02:02:01")[[1]])
    expect_equal(get_P_group("A*01:01:01:01")[[1]], "A*01:01P")
    expect_equal(get_P_group("A*01:01:01:01")[[1]], 
                 get_P_group("HLA-A*01:01:01:01")[[1]])
    expect_equal(get_P_group("DQB1*02:02:01")[[1]], 
                 
                 get_P_group("HLA-DQB1*02:02:01")[[1]])
})


context("Get MHC input from allele list")

test_that("get_mhcpan_input() returns error when arguments not adequate", {
    expect_error(get_mhcpan_input())
    expect_error(get_mhcpan_input(allele_list = "", mhc_class = "MHC-I"))
    expect_error(get_mhcpan_input(mhc_class = "MHC-I"))
    expect_error(get_mhcpan_input(allele_list = "A*01:01", mhc_class = "foo"))
    expect_error(get_mhcpan_input(allele_list = "foo", mhc_class = "MHC-I"))
})

test_that("get_mhcpan_input() returns error when alleles not in the list", {
    expect_error(get_mhcpan_input("A*01", mhc_class = "MHC-I"))
    expect_error(get_mhcpan_input("DRB1*01", mhc_class = "MHC-II"))
    expect_error(get_mhcpan_input("HLA-DRB1*01", mhc_class = "MHC-II"))
    expect_error(get_mhcpan_input("A*01:01", mhc_class = "MHC-II"))
    expect_error(get_mhcpan_input("DRB1*01:01", mhc_class = "MHC-I"))
})

test_that("get_mhcpan_input() returns expected results", {
    # MHC I
    expect_equal(get_mhcpan_input("A*01:01", mhc_class = "MHC-I"), "HLA-A01:01")
    expect_equal(get_mhcpan_input("A*01:01:01:01", mhc_class = "MHC-I"), 
                 "HLA-A01:01")
    expect_equal(get_mhcpan_input("HLA-A*01:01", mhc_class = "MHC-I"), 
                 "HLA-A01:01")
    # MHC II
    expect_equal(get_mhcpan_input("DRB1*01:01", mhc_class = "MHC-II"), 
                 "DRB1_0101")
    expect_equal(get_mhcpan_input(allele_list = "HLA-DRB1*01:01", 
                                  mhc_class = "MHC-II"), "DRB1_0101")
    expect_equal(length(get_mhcpan_input(allele_list = c("DPA1*01:03:01", 
                                                         "DPB1*14:01:01"), 
                                         mhc_class = "MHC-II")), 1)
})


context("MAC conversion")

test_that("encode_MAC() returns error when arguments not adequate", {
    expect_error(encode_MAC())
    expect_equal(encode_MAC(""), "glstring is empty")
    expect_error(encode_MAC("A*01:01", "A*01:02"))
    
    # this should return an error warning
    expect_equal(encode_MAC("foo"), 
                 "No Locus for allele: foo")
})

test_that("encode_MAC() returns expected results", {
    expect_equal(encode_MAC("A*01:01"), "A*01:01")
    expect_equal(encode_MAC(c("A*01:01", "A*01:02")), "A*01:AB")
})

test_that("decode_MAC() returns error when arguments not adequate", {
    expect_error(decode_MAC())
    expect_equal(decode_MAC(""), "'typing' parameter is missing")
    expect_error(decode_MAC("A*01:01", "A*01:02"))
    
    # this should return an error warning
    expect_equal(decode_MAC("foo"), "No asterisk in allele designation: 'foo'")
})

test_that("decode_MAC() returns expected results", {
    expect_is(decode_MAC("A*01:01"), "character")
    expect_is(decode_MAC("A*01:AB"), "character")
})

# MACUI from https://hml.nmdp.org/mac

# ENCODE --------

assemble_encode_curlopts <- function(allele_names) {
    # check that from same locus and right format
    hla_string <- paste(allele_names, collapse="/")
    hla_string
}

#' create_encode_handle
#'
#' @param allele_names  list of HLA alleles
#'
#' @return curl handle
#'
#'@keywords internal
create_encode_handle <- function(allele_names) {
    h <- curl::new_handle()
    opts_string <- assemble_encode_curlopts(allele_names)
    curl::handle_setopt(h, copypostfields = opts_string)
    curl::handle_setheaders(h, "Content-Type" = "text/plain")
}

#' fetch_encoded_MAC
#'
#' @param handle curl handle
#'
#' @return curl handle fetch
#'
#'@keywords internal
fetch_encoded_MAC <- function(handle) {
    # the function returns an understandable
    # error message if web resource not reachable
    res <- curl::curl_fetch_memory("https://hml.nmdp.org/mac/api/encode",
        handle = handle)
    res
}

#' @title Encode MAC 
#' @description Encode a list of HLA alleles into multiple allele code (MAC). 
#' The National Marrow Donor Program (NMDP) uses 
#' [MAC](https://bioinformatics.bethematchclinical.org/
#' hla-resources/allele-codes/allele-code-lists/) 
#' to facilitate the reporting and comparison of HLA alleles. MAC represent 
#' groups of HLA alleles and are useful when the 
#' HLA typing is ambiguous and does not allow to narrow down one single allele 
#' from a list of alleles.
#'
#' @param allele_list list of HLA alleles (e.g. c("A*01:01:01", "A*02:01:01", 
#' "A*03:01"))
#'
#' @return encoded MAC 
#' @export
#'
#' @examples
#' allele_list <- c("A*01:01:01", "A*02:01:01", "A*03:01")
#' encode_MAC(allele_list)
#' 
encode_MAC <- function(allele_list) {
    handle <- create_encode_handle(allele_list)
    curl_res <- fetch_encoded_MAC(handle)
    result <- rawToChar(curl_res$content)
    # warning message if result does not seem right
    if(result == "") {
        warning("encode_MAC function returned an empty string. Please check ",
            "input allele list", allele_list)
    } else {
        return(result)
    }
}

# DECODE -----

assemble_decode_url <- function(MAC) {
    # check that right format
    sprintf("https://hml.nmdp.org/mac/api/decode?typing=%s&expand=true",
        MAC)
}

fetch_decoded_MAC <- function(MAC) {
    url <- assemble_decode_url(MAC)
    h <- curl::new_handle()
    # the function returns an understandable
    # error message if web resource not reachable
    res <- curl::curl_fetch_memory(url, handle = h)
    res
}

#' @title Decode MAC
#' @description Decode a multiple allele code (MAC) into a list of HLA alleles.
#' #' The National Marrow Donor Program (NMDP) uses 
#' [MAC](https://bioinformatics.bethematchclinical.org/
#' hla-resources/allele-codes/allele-code-lists/) 
#' to facilitate the reporting and comparison of HLA alleles. MAC represent 
#' groups of HLA alleles and are useful when the 
#' HLA typing is ambiguous and does not allow to narrow down one single allele 
#' from a list of alleles.
#'
#' @param MAC multiple allele code (e.g. "A*01:ATJNV")
#'
#' @return list of HLA alleles
#' @export
#'
#' @examples
#' MAC <- "A*01:ATJNV"
#' decode_MAC(MAC)
#' 
decode_MAC <- function(MAC) {
    curl_res <- fetch_decoded_MAC(MAC)
    result <- rawToChar(curl_res$content)
    # warning message if result does not seem right
    if(result == "") {
        warning("decode_MAC function returned an empty string. Please check ",
            "input MAC", MAC)
    } else {
        return(result)
    }
}

# These are the functions used to query information of the MRO
# Helper function that are needed here are defined in MRO_interface_helper.R

#
#    Functions related to ORGANISM
#

#' @title get_valid_organisms
#' @description get the list of organisms that are part of the MRO annotation
#' @return list of organisms
#' @export
#'
#' @examples
#' get_valid_organisms()
#' 
get_valid_organisms <- function() {
    # Organism OBI:0100026
    organism_children <- mro.obo$children$`OBI:0100026`
    mro.obo$name[organism_children]
}

# define a (package internal) variable 
# get a list of all valid organisms 
valid_organisms <- get_valid_organisms()

# Sanity check for the user defined organism input
organism_input <- function(organism) {
    # error when organism wrong
    stopifnot("Organism name invalid" = organism %in% valid_organisms)
    # return the organism id
    names(valid_organisms)[organism == valid_organisms]
}

#
#    Functions related to SINGLE CHAINS
#

# for a given locus (defined by species and mhc-i, mhc-ii....)
# return all children that are proteins
# --> return all protein chains encoded in this locus
extract_mhc_type_table <- function(species_locus,
        protein_masked_intersections) {
    # get all descendants
    all_species_loci <- ontologyIndex::get_descendants(mro.obo, species_locus)
    # build a list of strings to find the gene products of the above descendants
    intersection_terms <- build_intersection(all_species_loci,
        type = "gene product of")
    # intersect to find gene product descendants that are proteins
    masked_protein_chains <- find_intersection_ids(intersection_terms,
        int_list = protein_masked_intersections)
    # get all children of the above defined categories
    all_chains <- mro.obo$children[mro.obo$id %in% masked_protein_chains]
    # assumption that ids are always 11 characters long
    chains <- unlist(all_chains, use.names = FALSE)
    # if there is a result result...
    if (!is.null(chains)) {
        # we assume that the ids are always 11 long
        names(chains) <- substr(names(unlist(all_chains)),1,11)
    }
    return(chains)
}

assemble_chain_lookup_table <- function(organism_id) {
    # get all MHC loci present in this organism, MHC locus: MRO:0000004
    loci_cat <- mro.obo$children[mro.obo$id == "MRO:0000004"]
    # for these 3 loci, get the id of the ones belonging to species of interest
    all_loci <- mro.obo$children[mro.obo$id %in% loci_cat[[1]]]
    # all entries belonging to taxon, "in taxon" relationship `RO:0002162`
    entries_for_species <- mro.obo$id[mro.obo$`RO:0002162` == organism_id]
    # for every locus select the entry belonging to the species of interest
    species_loci <- vapply(all_loci, intersect, y = entries_for_species,
        FUN.VALUE = character(1))
    species_loci <- species_loci[!vapply(species_loci, 
        function(X) {identical(X, y = character(0))}, FUN.VALUE = logical(1))]
    # protein masked ontology (to make it possible to intersect later)
    protein_masked_intersections <- mro.obo$intersection_of[grep("PR:000000001",
        mro.obo$intersection_of)]
    protein_mask <- names(protein_masked_intersections)
    # for all species_loci, get the table of chains
    tables <- lapply(species_loci, extract_mhc_type_table,
        protein_masked_intersections = protein_masked_intersections)
    # assemble the results into a dataframe
    unlisted_tables <- unlist(tables)
    names_chains <- names(unlisted_tables)
    chain_table <- data.frame(
        mhc_type_id = stringr::str_extract(names_chains, pattern = ".+(?=\\.)"),
        locus_id = stringr::str_extract(names_chains, pattern = "(?<=\\.).+"),
        chain_id = unlisted_tables)
    # remove categories such as HLA-DRB1 chain (child of HLA-DRB chain) 
    chain_table_filtered <- chain_table[!chain_table$chain_id %in% 
            protein_mask,]
    # get names of mhc type
    mhc_type_names <-  mro.obo$name[mro.obo$id %in% 
            unique(chain_table_filtered$mhc_type_id)]
    chain_table_filtered$mhc_type_names <- mhc_type_names[
            chain_table_filtered$mhc_type_id]
    # get names of loci
    locus_names <-  mro.obo$name[mro.obo$id %in%
            unique(chain_table_filtered$locus_id)]
    chain_table_filtered$locus_names <- locus_names[
            chain_table_filtered$locus_id]
    # get the names of chains
    chain_names <- mro.obo$name[mro.obo$id %in% chain_table_filtered$chain_id]
    chain_names_short <- stringr::str_extract(chain_names, 
        pattern = ".*(?= chain)")
    names(chain_names_short) <- names(chain_names)
    chain_table_filtered$chain_names <- chain_names_short[
            chain_table_filtered$chain_id]
    # get the chain sequence
    chain_sequences <- extract_protein_sequence(chain_table_filtered$chain_id)
    chain_table_filtered$chain_sequences <- chain_sequences
    return(chain_table_filtered)
}

#' @title Retrieve MHC chain lookup table
#'
#' @param organism name of organism (e.g. "human")
#'
#' @return Table containing MHC chain information for the organism. 
#' It contains chain names, MHC restriction and protein sequence.
#' @export
#'
#' @examples
#' retrieve_chain_lookup_table("mouse")
#' 
retrieve_chain_lookup_table <- function(organism) {
    
    organism_id <- organism_input(organism)
    # assemble the chain table
    assemble_chain_lookup_table(organism_id)
}

#
#    Functions related to PROTEIN COMPLEX
#

# build the table containing mhc_type, complex name, alpha, beta name etc...
# this is done individually for every mhc_type
# complex_sublist_list is a list containing the list of 
# complexes for evey mhc type (list of lists)
extract_mhc_complex_table <- function(complex_sublist_list, mhc_type) {
    # Need to access the name of the list entry
    complex_type <- names(complex_sublist_list)
    complex_sublist <- complex_sublist_list[[complex_type]]
    
    # check if list contains something
    if (length(complex_sublist) != 0) {
        # complex serotype
        complex_serotypes <- vapply(complex_sublist, get_complex_serotype,
            FUN.VALUE = character(1))
        serotypes_names_dict <- mro.obo$name[mro.obo$id %in%
                unique(complex_serotypes)]
        serotypes_names <- serotypes_names_dict[complex_serotypes]
        # name of protein complex
        complex_names <- mro.obo$name[mro.obo$id %in% complex_sublist]
        # status complete or partial
        complex_status <- vapply(complex_sublist, get_complex_status,
            FUN.VALUE = character(1))
        # chains that compose the locus
        complex_chains <- vapply(complex_sublist, get_complex_chains,
            FUN.VALUE = character(2))
        # alpha chain
        alpha_chains <- complex_chains[1,]
        # dict is used because the chains might be present in the 
        # list several times
        alpha_names_dict <- mro.obo$name[mro.obo$id %in% alpha_chains]
        alpha_names <- alpha_names_dict[alpha_chains]
        # beta chain
        beta_chains <- complex_chains[2,]
        
        beta_names_dict <- mro.obo$name[mro.obo$id %in% beta_chains]
        beta_names <- beta_names_dict[beta_chains]
        # build the table 
        complex_table <- data.frame(mhc_type = rep(mhc_type,
            length(complex_names)),
            complex_type = rep(complex_type, length(complex_names)),
            complex_name = complex_names, complex_status = complex_status,
            alpha_name = alpha_names, beta_name = beta_names,
            complex_serotype = complex_serotypes,
            serotype_name = serotypes_names, row.names = NULL)
        return(complex_table)
    } else {
        return(NULL)
    }
}



#' @title Assemble protein complex
#' @description Assemble a table or MHC protein complexes for a given organism.
#' 
#' @param organism  Organism for which the lookup should be built (e.g. 
#' "human", "mouse", ...). The list of valid 
#' organisms can be found using the function \code{get_valid_organisms}
#'
#' @return a data frame with the MHC complexes annotated in MRO (only 
#' completely annotated complexes are returned)
#' @export
#'
#' @examples
#' assemble_protein_complex(organism = "mouse")
#' 
assemble_protein_complex <- function(organism) {
    
    organism_id <- organism_input(organism)
    
    # MHC-I protein complex: MRO:0001355, MHC-II protein complex: MRO:0001356
    # nonclassical MHC protein complex MRO:0001464
    # get all protein complexes belonging to these entries and overlapping
    # with taxon queried
    complexes_mhc_level <- mro.obo$children[mro.obo$id %in%
            c("MRO:0001355", "MRO:0001356", "MRO:0001464")]
    
    # filter for taxon of interest
    entries_for_species <- mro.obo$id[grep(organism_id, 
        mro.obo$intersection_of)]
    species_complexes_mhc_level <- lapply(complexes_mhc_level, intersect,
        y = entries_for_species)
    # find all children - locus level
    complexes_locus_level <- mro.obo$children[mro.obo$id %in%
            species_complexes_mhc_level]
    
    # find the children with entries partial/complete molecule
    # for every complex locus level find all partial and complete 
    # descendant complexes
    complex_list <- lapply(complexes_locus_level, find_descendant_complexes)
    
    # create an empty dataframe for assembling info to come
    complete_table <- data.frame(mhc_type = character(0),
        complex_type = character(0), complex_name = character(0), 
        complex_status = character(0), alpha_name = character(0),
        beta_name = character(0), complex_serotype= character(0),
        serotype_name= character(0))
    # loop over mhc class
    for (mhc_type in names(complex_list)) {
        complex_sublist <- complex_list[[mhc_type]]
        
        # complex types
        complex_types <- names(complex_sublist)
        sub_tables <- lapply(complex_types, function(x) 
                        extract_mhc_complex_table(complex_sublist[x],
                            mhc_type = mhc_type))
        int_table <- do.call(rbind, sub_tables)
        complete_table <- rbind(complete_table, int_table)
    }
    
    return(complete_table)
}



# The protein complex table for humans can be assembled before, 
# because it takes quite some time
# get the protein lookup table
#' human_protein_complex_table
#' @details   \code{human_protein_complex_table}: human_protein_complex_table.
#' @export
#' 
#' @examples
#' # The human protein complex table is available in the following
#' # exported variable
#' human_protein_complex_table
human_protein_complex_table <- assemble_protein_complex(organism = "human")


#' @title Serotypes
#' @description Get the serotypes of the MHC complexes encoded by a list of 
#' MHC alleles.
#'
#' @param allele_list List of allele
#' @param organism  Organism to be used for MRO lookup. 
#' If the organism does not match the given allele, a empty object is returned.
#' @param mhc_type  ["MHC-I" or "MHC-II"] MHC class to use for MRO lookup.
#'
#' @return Named list of serotypes, which only contains complexes contained 
#' in the MRO. 
#' If no serotype is annoted for a given complex, the list element is NA.
#' @export
#'
#' @examples
#' allele_list <- c("A*01:01:01","B*27:01")
#' get_serotypes(allele_list, mhc_type = "MHC-I")
#' 
get_serotypes <- function(allele_list, organism = "human", mhc_type) {
    chain_list <- vapply(allele_list, reformat_allele, FUN.VALUE = character(1))
    
    # get the protein lookup table
    if (organism == "human") {
        protein_complexes <- human_protein_complex_table
    } else {
        protein_complexes <- assemble_protein_complex(organism)
    }
    
    # filter the matches to alpha name
    full_chain_list <- vapply(chain_list, function(X) paste0("HLA-", X,
        " chain"),
        FUN.VALUE = character(1))
    if (mhc_type == "MHC-I") {
        filtered_complexes <- protein_complexes[
            protein_complexes$alpha_name %in% full_chain_list, ]
    } else if (mhc_type == "MHC-II") {
        filtered_complexes <- protein_complexes[
            protein_complexes$alpha_name %in% full_chain_list & 
            protein_complexes$beta_name %in% full_chain_list, ]
    } else {stop("mhc_type needs to be MHC-I or MHC-II")}
    
    named_serotype_list <- filtered_complexes$serotype_name
    names(named_serotype_list) <- filtered_complexes$complex_name
    named_serotype_list 
}

context("ORGANISM")

test_that("get_organism() returns a list of organisms", {
    organisms <- get_valid_organisms()
    expect_is(organisms, "character")
    expect_equal(length(organisms), 23)
    expect_true("human" %in% organisms)
    expect_false("NCBITaxon:9606" %in% organisms)
    expect_false("human" %in% names(organisms))
    expect_true("NCBITaxon:9606" %in% names(organisms))
})

test_that("organism_input() distinguishes valid from non-valid organisms", {
    expect_equal(organism_input("human"), "NCBITaxon:9606")
    expect_error(organism_input("marsian"))
    expect_error(organism_input(""))
    expect_error(organism_input())
})


context("CHAIN LOOKUP TABLE")

test_that("retrieve_chain_lookup_table() returns error when arguments are not correct", {
    expect_error(retrieve_chain_lookup_table())
    expect_error(retrieve_chain_lookup_table("marsian"))
})

test_that("retrieve_chain_lookup_table() returns expected result for mouse", {
    m_df <- retrieve_chain_lookup_table("mouse")
    expect_is(m_df, "data.frame")
    
    # check that all loci are present
    expected_loci <- c("MHC class I locus","MHC class II locus","non-classical MHC locus")
    observed_loci <- unique(m_df$mhc_type_names)
    expect_equal(length(intersect(expected_loci, observed_loci)),3) 
})

test_that("retrieve_chain_lookup_table() returns expected result for human", {
    h_df <- retrieve_chain_lookup_table("human")
    expect_is(h_df, "data.frame")
    
    # check that all loci are present
    expected_loci <- c("MHC class I locus","MHC class II locus","non-classical MHC locus")
    observed_loci <- unique(h_df$mhc_type_names)
    expect_equal(length(intersect(expected_loci, observed_loci)),3) 
})

test_that("retrieve_chain_lookup_table() contains sequence information for human", {
    h_df <- retrieve_chain_lookup_table("human")
    expect_true(length(h_df$chain_sequences) > 0)
    expect_true(nchar(h_df$chain_sequences[[1]]) > 10)
})


context("SEROTYPES")

test_that("get_serotypes() returns error when arguments are not correct", {
    expect_error(get_serotypes())
    expect_error(get_serotypes(allele_list = "A*01:01"))
    expect_error(get_serotypes(allele_list = "A*01:01", mhc_type = "foo"))
    expect_error(get_serotypes(allele_list = "A*01:01", mhc_type = "MHC-I", 
                               organism = "marsian"))
    expect_error(get_serotypes(allele_list = "foo", mhc_type = "MHC-I"))
    expect_error(get_serotypes(allele_list = "foo", mhc_type = "MHC-II"))
    expect_error(get_serotypes(allele_list = c("A*01:01","foo"), 
                               mhc_type = "MHC-II"))
    
    # empty return when allele and organism not matching
    expect_equal(length(get_serotypes(allele_list = "A*01:01", 
                                      mhc_type = "MHC-I", organism = "mouse")), 
                 0)
    
    # correct query
    expect_equal(get_serotypes(allele_list = "A*01:01", 
                               mhc_type = "MHC-I")[[1]], "HLA-A1 serotype")
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/external_resources_input.R
\name{load_mro}
\alias{load_mro}
\title{load_mro}
\usage{
load_mro()
}
\value{
MRO in ontology_index format
}
\description{
load_mro
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MACUI_interface.R
\name{decode_MAC}
\alias{decode_MAC}
\title{Decode MAC}
\usage{
decode_MAC(MAC)
}
\arguments{
\item{MAC}{multiple allele code (e.g. "A*01:ATJNV")}
}
\value{
list of HLA alleles
}
\description{
Decode a multiple allele code (MAC) into a list of HLA alleles.
#' The National Marrow Donor Program (NMDP) uses 
[MAC](https://bioinformatics.bethematchclinical.org/
hla-resources/allele-codes/allele-code-lists/) 
to facilitate the reporting and comparison of HLA alleles. MAC represent 
groups of HLA alleles and are useful when the 
HLA typing is ambiguous and does not allow to narrow down one single allele 
from a list of alleles.
}
\examples{
MAC <- "A*01:ATJNV"
decode_MAC(MAC)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MRO_interface.R
\name{get_valid_organisms}
\alias{get_valid_organisms}
\title{get_valid_organisms}
\usage{
get_valid_organisms()
}
\value{
list of organisms
}
\description{
get the list of organisms that are part of the MRO annotation
}
\examples{
get_valid_organisms()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{read_population_detail}
\alias{read_population_detail}
\title{read_population_detail}
\usage{
read_population_detail(url, population_id)
}
\arguments{
\item{url}{url of the page containing population information}

\item{population_id}{numeric population identifier}
}
\value{
population information
}
\description{
read_population_detail
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_queries.R
\name{query_allele_frequencies}
\alias{query_allele_frequencies}
\title{Query allele frequencies}
\usage{
query_allele_frequencies(
  hla_locus = NA,
  hla_selection = NA,
  hla_population = NA,
  hla_country = NA,
  hla_region = NA,
  hla_ethnic = NA,
  hla_sample_size_pattern = NA,
  hla_sample_size = NA,
  standard = "a"
)
}
\arguments{
\item{hla_locus}{HLA locus that will be used for filtering data. A, B, C, 
DPA1, DPB1, DQA1, DQB1, DRB1}

\item{hla_selection}{Allele that will be used for filtering data. 
e.g. A*01:01}

\item{hla_population}{Numeric identifier of the population that will be used 
for filtering. This identifier is defined by the Allele Frequency 
Net Database.}

\item{hla_country}{Country of interest (e.g. Germany, France, ...).}

\item{hla_region}{Geographic region of interest 
(e.g. Europe, North Africa, ...)}

\item{hla_ethnic}{Ethnic origin of interest (e.g. Caucasoid, Siberian, ...)}

\item{hla_sample_size_pattern}{Keyword used to define the filtering for a 
specific population size. e.g. "bigger_than", "equal", "less_than", 
"less_equal_than", "bigger_equal_than"}

\item{hla_sample_size}{Integer number used to define the filtering for a 
specific population size, together with the hla_sample_size_pattern argument.}

\item{standard}{Population standards, as defined in the package vignette. 
"g" - gold, "s" - silver, "a" - all}
}
\value{
data.frame object containing the result of the allele frequency query
}
\description{
Query allele frequencies
}
\examples{

# select frequencies of the A*02:01 allele,
# for gold standard population with more than 10,000 individuals
sel <- query_allele_frequencies(hla_selection = "A*02:01",
hla_sample_size_pattern = "bigger_than", hla_sample_size = 10000,
standard="g")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nomenclature_queries.R
\name{get_G_group}
\alias{get_G_group}
\title{G groups}
\usage{
get_G_group(allele_list)
}
\arguments{
\item{allele_list}{List of alleles.}
}
\value{
Named list of G-groups the input alleles belong to.
}
\description{
Get the G groups for a list of HLA alleles. 
[G groups](http://hla.alleles.org/alleles/g_groups.html) are groups of 
HLA alleles that have identical nucleotide sequences across the exons 
encoding the peptide binding domains.
}
\examples{
allele_list <- c("DQB1*02:02:01", "DQB1*06:09:01")
get_G_group(allele_list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MRO_interface.R
\name{assemble_protein_complex}
\alias{assemble_protein_complex}
\title{Assemble protein complex}
\usage{
assemble_protein_complex(organism)
}
\arguments{
\item{organism}{Organism for which the lookup should be built (e.g. 
"human", "mouse", ...). The list of valid 
organisms can be found using the function \code{get_valid_organisms}}
}
\value{
a data frame with the MHC complexes annotated in MRO (only 
completely annotated complexes are returned)
}
\description{
Assemble a table or MHC protein complexes for a given organism.
}
\examples{
assemble_protein_complex(organism = "mouse")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{parse_allele_freq_html}
\alias{parse_allele_freq_html}
\title{parse_allele_freq_html}
\usage{
parse_allele_freq_html(allele_freq_table)
}
\arguments{
\item{allele_freq_table}{allele frequency table parsed from AFND website}
}
\value{
allele_freq_table reformatted
}
\description{
format the allele frequency table and select columns of interest
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{get_nb_pages}
\alias{get_nb_pages}
\title{get_nb_pages}
\usage{
get_nb_pages(page_tbl)
}
\arguments{
\item{page_tbl}{html input page}
}
\value{
integer number of pages in the html input
}
\description{
get_nb_pages
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MRO_interface.R
\name{retrieve_chain_lookup_table}
\alias{retrieve_chain_lookup_table}
\title{Retrieve MHC chain lookup table}
\usage{
retrieve_chain_lookup_table(organism)
}
\arguments{
\item{organism}{name of organism (e.g. "human")}
}
\value{
Table containing MHC chain information for the organism. 
It contains chain names, MHC restriction and protein sequence.
}
\description{
Retrieve MHC chain lookup table
}
\examples{
retrieve_chain_lookup_table("mouse")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{extract_population_name}
\alias{extract_population_name}
\title{extract_population_name}
\usage{
extract_population_name(data)
}
\arguments{
\item{data}{html input page}
}
\value{
population name
}
\description{
extract_population_name
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{check_sample_size}
\alias{check_sample_size}
\title{check_sample_size, stops if input not adequate}
\usage{
check_sample_size(hla_sample_size_pattern, hla_sample_size)
}
\arguments{
\item{hla_sample_size_pattern}{one of "bigger_than", "equal", "less_than", 
"less_equal_than", "bigger_equal_than","different"}

\item{hla_sample_size}{integer number used for population size}
}
\value{
TRUE
}
\description{
check_sample_size, stops if input not adequate
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{check_population}
\alias{check_population}
\title{check_population, stops if input not adequate}
\usage{
check_population(hla_population)
}
\arguments{
\item{hla_population}{population id}
}
\value{
TRUE
}
\description{
check_population, stops if input not adequate
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MRO_interface.R
\name{get_serotypes}
\alias{get_serotypes}
\title{Serotypes}
\usage{
get_serotypes(allele_list, organism = "human", mhc_type)
}
\arguments{
\item{allele_list}{List of allele}

\item{organism}{Organism to be used for MRO lookup. 
If the organism does not match the given allele, a empty object is returned.}

\item{mhc_type}{["MHC-I" or "MHC-II"] MHC class to use for MRO lookup.}
}
\value{
Named list of serotypes, which only contains complexes contained 
in the MRO. 
If no serotype is annoted for a given complex, the list element is NA.
}
\description{
Get the serotypes of the MHC complexes encoded by a list of 
MHC alleles.
}
\examples{
allele_list <- c("A*01:01:01","B*27:01")
get_serotypes(allele_list, mhc_type = "MHC-I")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/visualization.R
\name{plot_allele_frequency}
\alias{plot_allele_frequency}
\title{Plotting allele frequencies}
\usage{
plot_allele_frequency(allele_frequency)
}
\arguments{
\item{allele_frequency}{returned by \link{query_allele_frequencies}}
}
\value{
ggplot2 object displaying the allele frequencies on a world map.
}
\description{
\code{plot_allele_frequency} Generate a World map 
displaying the frequency of a given table of HLA alleles. Use the function
\link{query_allele_frequencies} to generate a table with allele frequencies.
}
\examples{

# select frequency of given allele
sel_allele_freq <- query_allele_frequencies(hla_selection = "A*02:01", 
hla_sample_size_pattern = "bigger_than", 
hla_sample_size = 10000, standard="g")

plot_allele_frequency(sel_allele_freq)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/external_resources_input.R
\docType{data}
\name{mro.obo}
\alias{mro.obo}
\title{MRO}
\format{
An object of class \code{ontology_index} of length 18.
}
\usage{
mro.obo
}
\description{
\code{mro.obo}: MHC Restriction Ontology obo file.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MRO_interface.R
\docType{data}
\name{human_protein_complex_table}
\alias{human_protein_complex_table}
\title{human_protein_complex_table}
\format{
An object of class \code{data.frame} with 12385 rows and 8 columns.
}
\usage{
human_protein_complex_table
}
\description{
human_protein_complex_table
}
\details{
\code{human_protein_complex_table}: human_protein_complex_table.
}
\examples{
# The human protein complex table is available in the following
# exported variable
human_protein_complex_table
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{check_geographics}
\alias{check_geographics}
\title{check_geographics, stops if input not adequate}
\usage{
check_geographics(country, region, ethnic)
}
\arguments{
\item{country}{country used for allele frequency selection}

\item{region}{geographical region used for allele frequency selection}

\item{ethnic}{ethical origin used for allele frequency selection}
}
\value{
TRUE
}
\description{
check_geographics, stops if input not adequate
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{verify_parameters}
\alias{verify_parameters}
\title{verify_parameters}
\usage{
verify_parameters(
  hla_locus,
  hla_selection,
  hla_population,
  hla_country,
  hla_region,
  hla_ethnic,
  hla_sample_size_pattern,
  hla_sample_size,
  standard = "a",
  query_type
)
}
\arguments{
\item{hla_locus}{locus of hla frequencies to query}

\item{hla_selection}{HLA alleles used for selection}

\item{hla_population}{population id}

\item{hla_country}{country used for allele frequency selection}

\item{hla_region}{geographical region used for allele frequency selection}

\item{hla_ethnic}{ethical origin used for allele frequency selection}

\item{hla_sample_size_pattern}{one of "bigger_than", "equal", "less_than", 
"less_equal_than", "bigger_equal_than","different"}

\item{hla_sample_size}{integer number used for population size}

\item{standard}{one of "a" - all,"s" - silver,"g" - gold}

\item{query_type}{"allele" or "haplotype"}
}
\value{
boolean to indicate, whether tests were passed
}
\description{
verify_parameters
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MACUI_interface.R
\name{fetch_encoded_MAC}
\alias{fetch_encoded_MAC}
\title{fetch_encoded_MAC}
\usage{
fetch_encoded_MAC(handle)
}
\arguments{
\item{handle}{curl handle}
}
\value{
curl handle fetch
}
\description{
fetch_encoded_MAC
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/external_resources_input.R
\name{getURL}
\alias{getURL}
\title{getURL}
\usage{
getURL(
  URL,
  N.TRIES = 2L,
  read_method = c("delim", "lines", "html"),
  skip = 0,
  delim = "\\t",
  col_names = TRUE
)
}
\arguments{
\item{URL}{Indicated the url that will be read}

\item{N.TRIES}{Integer, how often should the function try to read the URL?}

\item{read_method}{Method to be used for reading of URL content 
("delim" -> \code{readr::read_delim}, 
"lines" -> \code{readr::read_lines}, "html" -> \code{xml2::read_html})}

\item{skip}{integer indicating how many lines to skip when reading URL}

\item{delim}{pattern used for delim 
(passed to \code{delim} of read functions)}

\item{col_names}{list of colnames to use}
}
\value{
returns a the content of the URL. The format of the return object
depends on the read_method that was used.
}
\description{
getURL
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MACUI_interface.R
\name{create_encode_handle}
\alias{create_encode_handle}
\title{create_encode_handle}
\usage{
create_encode_handle(allele_names)
}
\arguments{
\item{allele_names}{list of HLA alleles}
}
\value{
curl handle
}
\description{
create_encode_handle
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nomenclature_queries.R
\name{get_P_group}
\alias{get_P_group}
\title{P groups}
\usage{
get_P_group(allele_list)
}
\arguments{
\item{allele_list}{list of HLA alleles}
}
\value{
Named list of P-groups the input alleles belong to.
}
\description{
Get the P groups for a list of HLA alleles. 
[P groups](http://hla.alleles.org/alleles/p_groups.html) are groups 
of HLA alleles that have identical protein sequences in the peptide binding 
domains.
}
\examples{
allele_list <- c("DQB1*02:02:01", "DQB1*06:09:01")
get_P_group(allele_list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{parse_haplotype_freq_html}
\alias{parse_haplotype_freq_html}
\title{parse_haplotype_freq_html}
\usage{
parse_haplotype_freq_html(haplotype_freq_table)
}
\arguments{
\item{haplotype_freq_table}{haplotype frequency table parsed
from AFND website}
}
\value{
haplotype_freq_table reformatted
}
\description{
format the haplotype frequency table and select 
columns of interest
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{read_complete_freq_table}
\alias{read_complete_freq_table}
\title{read_complete_freq_table}
\usage{
read_complete_freq_table(url, type)
}
\arguments{
\item{url}{URL of the website containing frequency table}

\item{type}{["allele"|"haplotype"]}
}
\value{
frequency table
}
\description{
read_complete_freq_table
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/external_resources_input.R
\name{get_external_file}
\alias{get_external_file}
\title{get_external_file}
\usage{
get_external_file(file, skip = 0, delim = "\\t", col_names = TRUE)
}
\arguments{
\item{file}{Indicated the file that will be read}

\item{skip}{integer indicating how many lines to skip when reading URL}

\item{delim}{pattern used for delim 
(passed to \code{delim} of read functions)}

\item{col_names}{list of colnames to use}
}
\value{
returns a the content of the file. The format of the return object
depends on the read_method that was used.
}
\description{
get_external_file
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{get_valid_geographics}
\alias{get_valid_geographics}
\title{get_valid_geographics}
\usage{
get_valid_geographics()
}
\value{
list of valid countries, regions and ethnic origin
}
\description{
get a list of valid countries, regions and ethnic origins
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{check_hla_selection}
\alias{check_hla_selection}
\title{check_hla_selection, stops if input not adequate}
\usage{
check_hla_selection(hla_selection, query_type)
}
\arguments{
\item{hla_selection}{HLA alleles used for selection}

\item{query_type}{["allele"|"haplotype"] type of AFND query}
}
\value{
TRUE
}
\description{
check_hla_selection, stops if input not adequate
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{check_standard}
\alias{check_standard}
\title{check_standard, stops if input not adequate}
\usage{
check_standard(standard)
}
\arguments{
\item{standard}{one of "a" - all,"s" - silver,"g" - gold}
}
\value{
TRUE
}
\description{
check_standard, stops if input not adequate
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_queries.R
\name{query_population_detail}
\alias{query_population_detail}
\title{Query population metainformation}
\usage{
query_population_detail(population_ids)
}
\arguments{
\item{population_ids}{List of numeric identifiers of the population that 
will be used for filtering. The identifier is defined by the Allele 
Frequency Net Database.}
}
\value{
data.frame object containing the result of the population detail 
query
}
\description{
Query population metainformation
}
\examples{
population_detail <- query_population_detail(0001986)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_queries.R
\name{query_haplotype_frequencies}
\alias{query_haplotype_frequencies}
\title{Query haplotype frequencies}
\usage{
query_haplotype_frequencies(
  hla_selection = NA,
  hla_population = NA,
  hla_country = NA,
  hla_region = NA,
  hla_ethnic = NA,
  hla_sample_size_pattern = NA,
  hla_sample_size = NA
)
}
\arguments{
\item{hla_selection}{Alleles that will be used to build the haplotype query. 
One entry per locus. If no entry for a given locus, the function will search 
for haplotypes that do not include specifications for this locus. If any 
allele for a given locus should be considered, the list entry should be 
"A*" or other locus in same format.}

\item{hla_population}{Numeric identifier of the population that will be used 
for filtering. Thie identifier is defined by the Allele Frequency Net 
Database.}

\item{hla_country}{Country of interest (e.g. Germany, France, ...).}

\item{hla_region}{Geographic region of interest (e.g. Europe, 
North Africa, ...)}

\item{hla_ethnic}{Ethnic origin of interest (e.g. Caucasoid, Siberian, ...)}

\item{hla_sample_size_pattern}{Keyword used to define the filtering for a 
specific population size. e.g. "bigger_than", "equal", "less_than", 
"less_equal_than", "bigger_equal_than"}

\item{hla_sample_size}{Integer number used to define the filtering for a 
specific population size, together with the hla_sample_size_pattern argument.}
}
\value{
data.frame object containing the result of the allele frequency query
}
\description{
Query haplotype frequencies
}
\examples{
# works only for one haplotype at a time
query_haplotype_frequencies(hla_selection = c("A*02:01", "B*", "C*"), 
hla_region = "Europe")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nomenclature_queries.R
\name{get_mhcpan_input}
\alias{get_mhcpan_input}
\title{Get format for NetMHCpan tools}
\usage{
get_mhcpan_input(allele_list, mhc_class)
}
\arguments{
\item{allele_list}{list of HLA alles (e.g. c("A*01:01:01","B*27:01"))}

\item{mhc_class}{["MHC-I"|"MHC-II"] indicated which NetMHC you want to use.}
}
\value{
protein chain list as formatted for MHCpan input
}
\description{
NetMHCpan tools for MHC-peptide binding prediction require 
HLA complex names in a specific format. \code{get_mhcpan_input} formats a 
list of HLA alleles into a list of NetMHC-formated complexes.
}
\examples{
allele_list <- c("A*01:01:01","B*27:01")
get_mhcpan_input(allele_list, mhc_class = "MHC-I")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MACUI_interface.R
\name{encode_MAC}
\alias{encode_MAC}
\title{Encode MAC}
\usage{
encode_MAC(allele_list)
}
\arguments{
\item{allele_list}{list of HLA alleles (e.g. c("A*01:01:01", "A*02:01:01", 
"A*03:01"))}
}
\value{
encoded MAC
}
\description{
Encode a list of HLA alleles into multiple allele code (MAC). 
The National Marrow Donor Program (NMDP) uses 
[MAC](https://bioinformatics.bethematchclinical.org/
hla-resources/allele-codes/allele-code-lists/) 
to facilitate the reporting and comparison of HLA alleles. MAC represent 
groups of HLA alleles and are useful when the 
HLA typing is ambiguous and does not allow to narrow down one single allele 
from a list of alleles.
}
\examples{
allele_list <- c("A*01:01:01", "A*02:01:01", "A*03:01")
encode_MAC(allele_list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_interface.R
\name{extract_sample_info}
\alias{extract_sample_info}
\title{extract_sample_info}
\usage{
extract_sample_info(data)
}
\arguments{
\item{data}{html input page}
}
\value{
sample information
}
\description{
extract_sample_info
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AFND_queries.R
\name{build_allele_group}
\alias{build_allele_group}
\title{Building a list of alleles to cover}
\usage{
build_allele_group(allele_selection)
}
\arguments{
\item{allele_selection}{HLA allele for whicht
the allele group should be built.}
}
\value{
list of alleles
}
\description{
\code{build_allele_group} e.g. A*01:01 -> A*01:01:01, 
A*01:01:02, A*01:01:03
}
\examples{
build_allele_group("A*01:01")
}
